/*
 * 30Nov2004 vd (Vladimir Degtyarenko) v3.2.1
 * 23Nov2004 vd (Vladimir Degtyarenko) 
 * 03May2004 vd (Vladimir Degtyarenko) 
 * 11Apr2003 vd (Vladimir Degtyarenko)
 * 14Sep2002 vd (Vladimir Degtyarenko)
 * Minor changes to make it work with Russian symbols
 * 
 * 13Apr2002 vd (Vladimir Degtyarenko)
 * alt'nicks, +(-)nopubmega on chanel
 *
 * 07Jun2001 vd (Vladimir Degtyarenko)
 * Changes to make it work with Russian symbols on eggdrop1.6.x
 */
/*
 * minor changes to make it work on eggdrop1.4 (guppy 27Jan2000)
 */
/*===========================================================================*/
/*
 *  Original Copyright (C) 1998/1999 Jason Hutchens
 *  Copyright (C) 2000 Steve Huston
 *
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the Free
 *  Software Foundation; either version 2 of the license or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the Gnu Public License for more
 *  details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */
/*===========================================================================*/

/*
 *		Please note, that I don't know much about licensing and legalities.  So
 *		far as I know, what I'm doing is fine; but if someone cares to point out
 *		my shortsightedness, feel free :P
 *
 *		This is a minor rewrite of the original megahal.c and megahal.h files
 *		to compile them in as a module for Eggdrop.  Guarantees: None,
 *		Warranties: none, etc.  Use at your own risk, if it makes your hdd
 *		become possessed, I don't care, yadda yadda yadda.  I'm not big on
 *		comments, but I'll try to note where changes were made.  In order to
 *		keep this as simple as possible, I'm leaving all previous comments and
 *		remarks in the code.
 *
 *		        Steve Huston (huston@elvis.rowan.edu)
 */

/*
 *		$Id: megahal.c,v 1.25 1999/10/21 03:42:48 hutch Exp hutch $
 *
 *		File:			megahal.c
 *
 *		Program:		MegaHAL v8r6
 *
 *		Purpose:		To simulate a natural language conversation with a psychotic
 *						computer.  This is achieved by learning from the user's
 *						input using a third-order Markov model on the word level.
 *						Words are considered to be sequences of characters separated
 *						by whitespace and punctuation.  Replies are generated
 *						randomly based on a keyword, and they are scored using
 *						measures of surprise.
 *
 *		Author:		Mr. Jason L. Hutchens
 *
 *		WWW:			http://ciips.ee.uwa.edu.au/~hutch/hal/
 *
 *		E-Mail:		hutch@ciips.ee.uwa.edu.au
 *
 *		Contact:		The Centre for Intelligent Information Processing Systems
 *						Department of Electrical and Electronic Engineering
 *						The University of Western Australia
 *						AUSTRALIA 6907
 *
 *		Phone:		+61-8-9380-3856
 *
 *		Facsimile:	+61-8-9380-1168
 *
 *		Notes:		- This file is best viewed with tabstops set to three spaces.
 *						- To the Debian guys, yes, it's only one file, so shoot me!
 *						  I had to get it to work on DOS with crappy compilers and
 *						  I didn't want to spend more time than was neccessary.
 *						  Hence it's rather monolithic.  Also, an email would be
 *						  appreciated whenever bugs were fixed/discovered.  I've
 *						  terminated all of the memory leakage bugs AFAICT.  But
 *						  it does allocate a helluva lot of memory, I'll admit!
 *
 *		Compilation Notes
 *		=================
 *
 *		When compiling, be sure to link with the maths library so that the
 *		log() function can be found.
 *
 *		On the Macintosh, add the library SpeechLib to your project.  It is
 *		very important that you set the attributes to Import Weak.  You can
 *		do this by selecting the lib and then use Project Inspector from the
 *		Window menu.
 *
 *		CREDITS
 *		=======
 *
 *		Amiga (AmigaOS)
 *		---------------
 *		Dag Agren (dagren@ra.abo.fi)
 *
 *		DEC (OSF)
 *		---------
 *		Jason Hutchens (hutch@ciips.ee.uwa.edu.au)
 *
 *		Macintosh
 *		---------
 *		Paul Baxter (pbaxter@assistivetech.com)
 *		Doug Turner (dturner@best.com)
 *
 *		PC (Linux - Debian package)
 *		---------------------------
 *		Joey Hess (joeyh@master.debian.org)
 *
 *		PC (OS/2)
 *		---------
 *		Bjorn Karlowsky (?)
 *
 *		PC (Windows 3.11)
 *		-----------------
 *		Jim Crawford (pfister_@hotmail.com)
 *
 *		PC (Windows '95)
 *		----------------
 *		Jason Hutchens (hutch@ciips.ee.uwa.edu.au)
 *
 *		PPC (Linux)
 *		-----------
 *		Lucas Vergnettes (Lucasv@sdf.lonestar.org)
 *
 *		SGI (Irix)
 *		----------
 *		Jason Hutchens (hutch@ciips.ee.uwa.edu.au)
 *
 *		Sun (SunOS)
 *		-----------
 *		Jason Hutchens (hutch@ciips.ee.uwa.edu.au)
 */
/*===========================================================================*/
#define MAKING_MEGAHAL
#define MODULE_NAME "megahal"
#define MODULE_VERSION "v3.2.1, changes on 30Nov2004"
#include <errno.h>
#include "src/mod/module.h"
#include "server.mod/server.h"
#include "channels.mod/channels.h"
#include "irc.mod/irc.h"
#include <stdlib.h>
/* megahal preproc directives */
#include <stdio.h>
#include <stdarg.h>
/* #include <malloc.h> */
#include <string.h>
#include <signal.h>
#include <time.h>
#include <ctype.h>
#include <sys/types.h> 
#include <math.h>
/* End megahal preproc directives */
#include "megahal.h"

#undef global

/*
 * This might be ugly, but here's the predefinitiions of the functions in the
 * code for MegaHAL... they were at the top of megahal.c, so they're here too.
 * Maybe someday I'll clean this up and remove the ones not needed.
 */

static void add_aux(MODEL *, DICTIONARY *, STRING);
static void add_key(MODEL *, DICTIONARY *, STRING);
static void add_node(TREE *, TREE *, int);
static void add_swap(SWAP *, unsigned char *, unsigned char *);
static TREE *add_symbol(TREE *, BYTE2);
static BYTE2 add_wordnew(DICTIONARY *, STRING, int);
static BYTE2 add_word(DICTIONARY *, STRING);
static int babble(MODEL *, DICTIONARY *, DICTIONARY *);
static bool boundary(unsigned char *, int);
static void capitalize(unsigned char *);
static void change_personality(DICTIONARY *, int, MODEL **);
static bool dissimilar(DICTIONARY *, DICTIONARY *);
static void error(char *, char *, ...);
static float evaluate_reply(MODEL *, DICTIONARY *, DICTIONARY *);
static TREE *find_symbol(TREE *, int);
static TREE *find_symbol_add(TREE *, int);
static BYTE2 find_word(DICTIONARY *, STRING);
static void free_dictionary(DICTIONARY *);
static void free_model(MODEL *);
static void free_tree(TREE *);
static void free_word(STRING *);
static void free_words(DICTIONARY *);
static void free_swap(SWAP *);
static unsigned char *generate_reply(MODEL *, DICTIONARY *);
static void initialize_context(MODEL *);
static void initialize_dictionary(DICTIONARY *);
static DICTIONARY *initialize_list(char *);
static SWAP *initialize_swap(char *, bool);
static void learn(MODEL *, DICTIONARY *);
static void load_dictionary(FILE *, DICTIONARY *);
static bool load_model(char *, MODEL *);
static void load_personality(MODEL **);
static void load_tree(FILE *, TREE *);
static void load_word(FILE *, DICTIONARY *);
static DICTIONARY *make_keywords(MODEL *, DICTIONARY *);
static unsigned char *make_output(DICTIONARY *);
static void make_greeting(DICTIONARY *);
static bool make_words(unsigned char *, DICTIONARY *);
static DICTIONARY *new_dictionary(void);
static MODEL *new_model(int);
static TREE *new_node(void);
static SWAP *new_swap(void);
static DICTIONARY *reply(MODEL *, DICTIONARY *);
static void save_dictionary(FILE *, DICTIONARY *);
static void save_model(char *, MODEL *);
static void save_tree(FILE *, TREE *);
static void save_word(FILE *, STRING);
static int search_dictionary(DICTIONARY *, STRING, bool *);
static int search_node(TREE *, int, bool *);
static int seed(MODEL *, DICTIONARY *);
static void show_dictionary(DICTIONARY *);
static void train(MODEL *, char *);
static void update_context(MODEL *, int);
static void update_model(MODEL *, int);
static void upper(unsigned char *);
static bool warn(char *, char *, ...);
static int wordcmp(STRING, STRING);
static bool word_exists(DICTIONARY *, STRING);
static int rnd(int);
static int order=3;
static int timeout=2;
static DICTIONARY *ban=NULL;
static DICTIONARY *aux=NULL;
static DICTIONARY *grt=NULL;
static SWAP *swp=NULL;
static bool used_key;
static char *directory=NULL;
static char *last=NULL;
/* end predefinitions */

/*  vd  */

static unsigned char maltnick0[NICKLEN];
static char meg_codepage[20] = "cp1251";
static unsigned char megpatch[255] = ".";
static unsigned char megfileprefix[120] = "megahal";
static unsigned char meglogpatch[255] = "megahallog";
static unsigned char meg_cmdchars[40] = "!$%&.";
static unsigned char meg_ignoreflag[10] = "b";
static unsigned char meg_noignoreflag[10] = "n";
static int meg_msgreplays = 1;
static int meg_msglog = 1;
static int meg_msglearn = 1;
/* meg_floodcontrol */
static int meg_flood_count=0;
static int meg_flood_time=0;
static int meg_ignore_isflood=0;
static int meg_badword = 0;
static int meg_noswapbadword = 0;
/* meg_repeatcontrol */
static int meg_ignore_isrepeat=1;
static int meg_repeat_count=3;
static int meg_repeat_time=5;
static int meg_ignore_isrepeat_time=30;
static time_t systime;
static int megfreemodecount=0;

static SWAP       *mat=NULL;
static DICTIONARY *mynicks=NULL;
static DICTIONARY *key=NULL;
static DICTIONARY *hello=NULL;
static USERS      *usr=NULL;
static LOGS       *logbuf=NULL;
static int usersposition = -1;

static char badchar[]="\\/%{}[]<>|}:;";
static char charspaces[]= " !.?,:;()/_#-[]\042\140\134*+=<>\047@{}";
static unsigned char logfilename[512];
static int globsize;
static int minlennick;
static unsigned char nullchar[] = "!";
static unsigned char *transtab[128];

static unsigned char meg_tolowertab[256];
static unsigned char meg_touppertab[256];
static unsigned char meg_is[256];
static unsigned char inbuffer[INBUFSIZE];
static unsigned char eggdrop_logbuffer[INBUFSIZE];
static unsigned char eggdrop_logchan[128];

int meg_strcasecmp(const unsigned char *, const unsigned char *);

static unsigned char *find_mynicks(unsigned char *);

static void unload_personality(MODEL **);
static void free_alldic(void);

static bool swap_badwords(DICTIONARY *);
static FILE *open_logfile(char *);

static void save_msg(MODEL *);
static void msgsave_tree(FILE *, TREE *);
static void msg_makeoutput(char *, int *, BYTE2);
static void msg_cleartreeusage(TREE *);
static void msg_restoretreeusage(TREE *);

static int expmem_model(void);
static int expmem_tree(TREE *);
static int expmem_dictionary(DICTIONARY *);
static int expmem_swap(SWAP *);
static void appendload(MODEL **);
static int findminlengch_dictionary(DICTIONARY *);
static void initialize_translit(void);
static void initialize_codepage(void);
static unsigned char *totranslit(unsigned char *);
static FILE *openfile(char *, char *);
/* lib for USERS */
static USERS *new_users(void);

static BYTE2 add_user(USERS *, STRING);
static void save_users(USERS *, char *);
static void free_users(USERS *);

static USERS *initialize_users(char *);
static void megahal_writeuserfile(void);
static void megahal_clearhello(void);
static bool getbaduser(USERS *, char *, struct userrec *);
static bool isignorebyflood(USERS *, int);
static bool detectflood(MSGFLOOD *);
static bool isignorebybadword(USERS *, int);
static void ignoreuserbadwords(USERS *, char *);
static bool isfreereplay(char *, DICTIONARY *);

static LOGS *new_logbuffer(void);
static void add_logbuffer(char *, char *, ...);
static void save_pool(LOGPOOL *, STRING *);
static void save_logbuffer(void);
static int expmem_users(USERS *);
static int matchattr (struct userrec *, char *, char *) ;
static int Tcl_MegEncodingConvertFrom(Tcl_Interp *, char *, char *);
static int Tcl_MegEncodingConvertTo(Tcl_Interp *, char *, char *, int);
static int Tcl_MegConvertToUpLo(Tcl_Interp *, char *, char *, bool);
/* static int Tcl_MegEncodingConvertTo(Tcl_Interp *, char *, Tcl_Obj *, int); */

/* static void save_swap(SWAP *, char *); */

/* end vd  */

/*
 * Herein lies the code kluge of the century.. and it's only January :P  This
 * is the beginning of some hacking to keep functions happy.  I'm sure that
 * it's ugly, but it should work.  Yes, you guessed it: Global variables.
 * Only way (I think) that MegaHAL can keep track of its personality, as well
 * as what it currently knows.  These were defined in main() before, but in
 * here there is no main, so....
 */
static DICTIONARY *words=NULL; 

static DICTIONARY *greet=NULL; 

static MODEL *model=NULL;

static Function *global = NULL;
static Function *irc_funcs = NULL; 
static Function *server_funcs = NULL; 
static Function *channels_funcs = NULL;

static int megahal_expmem()
{
  register int i;
  int size = 0;

  globsize = 0;
  size += expmem_model();
  size += expmem_dictionary(ban);
  size += expmem_dictionary(aux);
  size += expmem_dictionary(grt);
  size += expmem_dictionary(mynicks);
  size += expmem_dictionary(key);
  size += expmem_dictionary(hello);
  size += expmem_swap(swp);
  size += expmem_swap(mat);
  size += expmem_users(usr);

/* Calc size of transtab */
  for(i=0;i<128;i++) {
    size += (strlen(transtab[i]) + 1);
  }
  size += (128 * 4 + 4);

  return size;
}

/*
 * Next, a hacked attempt at strdup(), since I can't use malloc() anywhere.
 */

static unsigned char *mystrdup(const unsigned char *s) {
	unsigned char *mytmp = nmalloc(strlen(s)+1);
	if (mytmp==NULL) return NULL;
	else strcpy(mytmp, s);

	return mytmp;
}

/* Here it is, the attempt at MegaHAL for Eggdrop bots... */
static int mystrncpy(char *dst, char *src, int len)
{
	char *tmp = dst;

	while ((*src) && (len--))
	  *tmp++ = *src++;

	*tmp = 0;
	return (tmp-dst);
}

static int mynewsplit(char *dst, char *src, int len)
{
	char *tmp = dst;

	while (*src==' ') src++;
	while ((*src) && (*src!=' ') && (len--))
	  *tmp++ = *src++;

	*tmp = 0;
	return (tmp-dst);
}

static bool isreplay(unsigned char *text, char *host)
{
	mystrncpy(inbuffer,text,INBUF);

	upper(inbuffer);

	if (make_words(inbuffer, words)) {
	  if (meg_badword) {
	    if (meg_badword > 1) {
	      ignoreuserbadwords(usr, host);
	    }
	    return FALSE;
	  }
	}
	return TRUE;
}

static bool mycheck_tcl_bind(tcl_bind_list_t *tl, const char *match)
{
  tcl_bind_mask_t *tm, *tm_last = NULL;

  for (tm = tl->first; tm ; tm_last = tm, tm = tm->next) {
    if (tm->flags & TBM_DELETED) continue;
    if (!meg_strcasecmp(match, tm->mask)) return TRUE;
  }
  return FALSE;
}

static int save_eggdroplog(void)
{
	if (eggdrop_logbuffer[0]) {
	  putlog(LOG_PUBLIC, eggdrop_logchan, "%s",eggdrop_logbuffer);
	  eggdrop_logbuffer[0] = 0;
	}
	return 0;
}

static void do_freemode(char *nick, char *host, char *hand, char *channel, unsigned char *text)
{
	unsigned char *halreply;
	bool replaymode;
	Context;
	
	if (!isreplay(text, host)) return;

	if (!(replaymode = isfreereplay(channel, words))) {
	  if (ngetudef("megfreelearn", channel)==2) {
	    add_logbuffer("learn", "%s\n", text);
	    learn(model, words);
	  }
	  return;
	}

	if (ngetudef("megfreelearn", channel) > 0) {
	  add_logbuffer("learn", "%s\n", text);
	  learn(model, words);
	}

	if (replaymode == HELLO) make_greeting(words);

	halreply=generate_reply(model, words);
	capitalize(halreply);

	if (ngetudef("nologmega", channel)==0) {
	  add_logbuffer(channel, "<%s> %s\n", nick, text);
	  add_logbuffer(channel, "<%s> %s\n", maltnick0, halreply);
	}

	dprintf(DP_HELP, "PRIVMSG %s :%s\n", channel, halreply);

	mystrncpy(eggdrop_logchan,channel,127);
	sprintf(eggdrop_logbuffer, "<%s> %s", maltnick0, halreply);

	return;
}

static int msgm_megahal(char *nick, char *host, struct userrec *u, unsigned char *text)
{
	unsigned char *inputtext, *halreply;
	
	if(!meg_msgreplays) return 0;
	if(strchr(meg_cmdchars, text[0]) !=NULL) return 0;

	Context;

	mynewsplit(inbuffer,text,INBUF);

	if (mycheck_tcl_bind((p_tcl_bind_list)H_msg, inbuffer)) return 0;

	systime = time(NULL);
	if (getbaduser(usr, host, u)) return 0;

	inputtext = find_mynicks(text);
	if (inputtext == NULL) inputtext = text;

	if (!isreplay(inputtext, host)) return 0;

	if (meg_msglearn) {
	  add_logbuffer("learn", "%s\n", inputtext);
	  learn(model, words);
	}
	halreply=generate_reply(model, words);
	capitalize(halreply);

	if(meg_msglog) {
	  add_logbuffer(nick, "<%s> %s\n", nick, inputtext);
	  add_logbuffer(nick, "<%s> %s\n", maltnick0, halreply);
	}

	dprintf(DP_HELP, "PRIVMSG %s :%s\n", nick, halreply);
	return 0;
}

static int pubm_megahal(char *nick, char *host, char *hand, char *channel, unsigned char *text)
{
	unsigned char *inputtext, *halreply;
	struct userrec *u=NULL;

	Context;
	save_eggdroplog();

	if(strchr(meg_cmdchars, text[0]) !=NULL) return 0;

	systime = time(NULL);
	if (hand!=NULL) u = get_user_by_handle(userlist, hand);

	if (getbaduser(usr, host, u)) return 0;

	inputtext = find_mynicks(text);

	if (inputtext==NULL) {
	  do_freemode(nick, host, hand, channel, text);
	  return 0;
	}
	if (ngetudef("nopubmega", channel)) return 0;

	if (!isreplay(inputtext, host)) return 0;

	if (!ngetudef("nomeglearn", channel)) {
	  add_logbuffer("learn", "%s\n", inputtext);
	  learn(model, words);
	}
	halreply=generate_reply(model, words);
	capitalize(halreply);

	if (!ngetudef("nologmega", channel)) {
	  add_logbuffer(channel, "<%s> %s: %s\n", nick, maltnick0, inputtext);
	  add_logbuffer(channel, "<%s> %s: %s\n", maltnick0, nick, halreply);
	}

	dprintf(DP_HELP, "PRIVMSG %s :%s: %s\n", channel, nick, halreply);

	mystrncpy(eggdrop_logchan,channel,127);
	sprintf(eggdrop_logbuffer, "<%s> %s: %s", maltnick0, nick, halreply);

	return 0;
}

static int msg_save_brain(char *nick, char *host, struct userrec *u, unsigned char *text)
{
	Context;
	putlog(LOG_MISC, "*", "Brain saved by %s", nick);
	dprintf(DP_SERVER, "PRIVMSG %s :Brain saved.\n",nick);
	save_model(".brn", model);
	save_msg(model);
	return 0;
}
static int msg_reload_brain(char *nick, char *host, struct userrec *u, unsigned char *text)
{
	Context;
	putlog(LOG_MISC, "*", "Brain reload by %s", nick);
	dprintf(DP_SERVER, "PRIVMSG %s :Brain reload.\n",nick);
	change_personality(NULL, 0, &model);
	return 0;
}
static int msg_appendload_brain(char *nick, char *host, struct userrec *u, unsigned char *text)
{
	Context;
	putlog(LOG_MISC, "*", "Brain appendload by %s", nick);
	dprintf(DP_SERVER, "PRIVMSG %s :Brain appendload.\n",nick);
	appendload(&model);
	return 0;
}

static int dcc_save_brain(struct userrec *u, int idx, char *par)
{
	Context;
	putlog(LOG_MISC, "*", "Brain saved by %s", dcc[idx].nick);
	save_model(".brn", model);
	save_msg(model);
	return 0;
}
static int dcc_reload_brain(struct userrec *u, int idx, char *par)
{
	Context;
	putlog(LOG_MISC, "*", "Brain reload by %s", dcc[idx].nick);
	change_personality(NULL, 0, &model);
	return 0;
}
static int dcc_appendload_brain(struct userrec *u, int idx, char *par)
{
	Context;
	putlog(LOG_MISC, "*", "Brain appendload by %s", dcc[idx].nick);
	appendload(&model);
	return 0;
}

static int megahal_action(char *nick, char *uhost, char *hand, char *chan, char *key, char *rest)
{
	return save_eggdroplog();
}
static int megahal_kick(char *nick, char *uhost, char *hand, char *chan, char *victim, char *reason)
{
	return save_eggdroplog();
}
static int megahal_mode(char *nick, char *uhost, char *hand, char *chan, char *mode, char *victim)
{
	return save_eggdroplog();
}
static int megahal_nick(char *nick, char *uhost, char *hand, char *chan, char *newnick)
{
	return save_eggdroplog();
}
static int megahal_join(char *nick, char *uhost, char *hand, char *chan)
{
	return save_eggdroplog();
}
static int megahal_part(char *nick, char *uhost, char *hand, char *chan)
{
	return save_eggdroplog();
}
static int megahal_sign(char *nick, char *uhost, char *hand, char *chan, char *reason)
{
	return save_eggdroplog();
}

static tcl_strings my_tcl_strings[] =
{
  {"nick", maltnick0, NICKLEN, 0},
  {"meg_codepage", meg_codepage, 20, 0},
  {"meg_patch", megpatch, 255, 0},
  {"meg_file_prefix", megfileprefix, 120, 0},
  {"meg_log_patch", meglogpatch, 255, 0},
  {"meg_cmdchars", meg_cmdchars, 40, 0},
  {"meg_ignoreflag", meg_ignoreflag, 10, 0},
  {"meg_noignoreflag", meg_noignoreflag, 10, 0},
  {0, 0, 0, 0}
};

static tcl_ints my_tcl_ints[] =
{
  {"meg_msgreplays", &meg_msgreplays, 0},
  {"meg_msglearn", &meg_msglearn, 0},
  {"meg_msglog", &meg_msglog, 0},
  {"meg_ignore_isflood",&meg_ignore_isflood, 0},
  {"meg_badword",&meg_badword,0},
  {"meg_noswapbadword",&meg_noswapbadword,0},
  {"meg_ignore_isrepeat",&meg_ignore_isrepeat, 0},
  {"meg_ignore_isrepeat_time",&meg_ignore_isrepeat_time, 0},
  {0, 0, 0}
};

static tcl_coups my_tcl_coups[] =
{
  {"meg_flood", &meg_flood_count, &meg_flood_time},
  {"meg_repeat", &meg_repeat_count, &meg_repeat_time},
  {0, 0, 0}
};

static cmd_t mega_dcc[] =
{
  {"brainsave", "n", dcc_save_brain, NULL},
  {"brainreload", "n", dcc_reload_brain, NULL},
  {"brainappendload", "n", dcc_appendload_brain, NULL},
  {NULL, NULL, NULL, NULL},
};

static cmd_t mega_msgm[] =
{
  {"*", "", msgm_megahal, NULL}, 
  {NULL, NULL, NULL, NULL},
};

static cmd_t mega_msg[] =
{
  {"brainsave", "n", msg_save_brain, NULL},
  {"brainreload", "n", msg_reload_brain, NULL},
  {"brainappendload", "n", msg_appendload_brain, NULL},
  {NULL, NULL, NULL, NULL},
};

static cmd_t mega_pubm[] =
{
  {"*",		"",	pubm_megahal,	"megahal"},
  {NULL,	NULL,	NULL,		NULL}
};

static cmd_t mega_ctcp[] =
{
  {"ACTION", "", (Function) megahal_action, "megahal"},
  {0, 0, 0, 0}
};

static cmd_t mega_kick[] =
{
  {"*", "", (Function) megahal_kick, "megahal"},
  {0, 0, 0, 0}
};

static cmd_t mega_mode[] =
{
  {"*", "", (Function) megahal_mode, "megahal"},
  {0, 0, 0, 0}
};

static cmd_t mega_nick[] =
{
  {"*", "", (Function) megahal_nick, "megahal"},
  {0, 0, 0, 0}
};

static cmd_t mega_join[] =
{
  {"*", "", (Function) megahal_join, "megahal"},
  {0, 0, 0, 0}
};

static cmd_t mega_part[] =
{
  {"*", "", (Function) megahal_part, "megahal"},
  {0, 0, 0, 0}
};

static cmd_t mega_sign[] =
{
  {"*", "", (Function) megahal_sign, "megahal"},
  {0, 0, 0, 0}
};

/* a report on the module status */
static void megahal_report(int idx, int details)
{
  int size;

  Context;
  size = megahal_expmem();

  if (details) {
/*
    dprintf(idx, "    Original Copyright (C) 1998/1999 Jason Hutchens \"hutch\"\n");
    dprintf(idx, "    Copyright (C) 2000 Steve Huston\n");
    dprintf(idx, "    Copyright (C) 2001/2004 Vladimir Degtyarenko \"vd\"\n");
*/
    dprintf(idx, "    dev. by vd, %s\n", MODULE_VERSION);
    dprintf(idx, "    Module codepage is %s\n", meg_codepage);
    dprintf(idx, "    Memory usage  : %d bytes\n", size);
    dprintf(idx, "    Unique words  : %d\n", model->forward->branch);
    dprintf(idx, "    Total words   : %d\n", model->forward->usage);
    dprintf(idx, "    Total messages: %d\n", model->forward->tree[0]->count);
    dprintf(idx, "    Dictionaries: .grt %d; .aux %d; .ban %d; .swp %d; .mat %d .nick %d;\n",grt->size,aux->size,ban->size,swp->dictionary->size,mat->dictionary->size,mynicks->size);
    dprintf(idx, "                  .hello %d; .key %d\n",hello->size,key->size);
    dprintf(idx, "  megahal msg commands:\n");
    dprintf(idx, "    /msg %s brainsave\n", maltnick0);
    dprintf(idx, "    /msg %s brainreload\n", maltnick0);
    dprintf(idx, "    /msg %s brainappendload\n", maltnick0);
    dprintf(idx, "  megahal dcc commands:\n");
    dprintf(idx, "    .brainsave\n");
    dprintf(idx, "    .brainreload\n");
    dprintf(idx, "    .brainappendload\n");
  } else
    dprintf(idx, "    Megahal Memory usage: %d bytes\n", size);

}

static char *megahal_close()
{
	Context;
	save_eggdroplog();
	del_hook(HOOK_5MINUTELY, (Function) save_logbuffer);
	del_hook(HOOK_USERFILE, (Function) megahal_writeuserfile);
	del_hook(HOOK_DAILY, (Function) megahal_clearhello);

	unload_personality(&model);

	rem_builtins(H_dcc, mega_dcc);
	rem_builtins(H_pubm, mega_pubm);
	rem_builtins(H_msgm, mega_msgm);
	rem_builtins(H_msg, mega_msg);

	rem_builtins(H_ctcp, mega_ctcp);
	rem_builtins(H_kick, mega_kick);
	rem_builtins(H_mode, mega_mode);
	rem_builtins(H_nick, mega_nick);
	rem_builtins(H_join, mega_join);
	rem_builtins(H_sign, mega_sign);
	rem_builtins(H_part, mega_part);

        rem_tcl_strings(my_tcl_strings);
	rem_tcl_ints(my_tcl_ints);
	rem_tcl_coups(my_tcl_coups);

	module_undepend(MODULE_NAME);
	return NULL;
}

#if defined (__CYGWIN__) && !defined(STATIC)
__declspec(dllexport) char * __cdecl megahal_start();
#else
char *megahal_start();
#endif

static Function megahal_table[] =
{
  (Function) megahal_start,
  (Function) megahal_close,
  (Function) megahal_expmem,
  (Function) megahal_report,
};

char *megahal_start(Function * global_funcs)
{
	global = global_funcs;
	Context;
	module_register(MODULE_NAME, megahal_table, 3, 02);
	if (!(channels_funcs = module_depend(MODULE_NAME, "channels", 1, 0)))
	  return "You need the channels module to use the megahal module.";
	if (!(server_funcs = module_depend(MODULE_NAME, "server", 1, 0)))
	  return "You need the server module to use the megahal module.";
	if (!(irc_funcs = module_depend(MODULE_NAME, "irc", 1, 0)))
	  return "You need the irc module to use the megahal module.";

	eggdrop_logbuffer[0] = 0;

        add_tcl_strings(my_tcl_strings);
	add_tcl_ints(my_tcl_ints);
	add_tcl_coups(my_tcl_coups);

	add_builtins(H_dcc, mega_dcc);
	add_builtins(H_pubm, mega_pubm);
	add_builtins(H_msgm, mega_msgm);
	add_builtins(H_msg, mega_msg);

/* events for save_eggdroplog() */
	add_builtins(H_ctcp, mega_ctcp);
	add_builtins(H_kick, mega_kick);
	add_builtins(H_mode, mega_mode);
	add_builtins(H_nick, mega_nick);
	add_builtins(H_join, mega_join);
	add_builtins(H_sign, mega_sign);
	add_builtins(H_part, mega_part);
/* end of events -------------- */

	systime = time(NULL);
	words  = new_dictionary(); 
	greet     = new_dictionary();

	initudef(UDEF_FLAG, "nopubmega", 1);
	initudef(UDEF_FLAG, "nologmega", 1);
	initudef(UDEF_FLAG, "megfreekey", 1);
	initudef(UDEF_FLAG, "nomeglearn", 1);
	initudef(UDEF_FLAG, "nomegfreehello", 1);
	initudef(UDEF_INT,  "megfreelearn", 1);
	initudef(UDEF_INT,  "megfreemode", 1);

	change_personality(NULL, 0, &model);
	minlennick = findminlengch_dictionary(mynicks);

	add_hook(HOOK_5MINUTELY, (Function) save_logbuffer);
	add_hook(HOOK_USERFILE, (Function) megahal_writeuserfile);
	add_hook(HOOK_DAILY, (Function) megahal_clearhello);

	putlog(LOG_MISC, "*", "megahal.mod %s, module codepage is %s", MODULE_VERSION, meg_codepage);
	
	return NULL;
}

/*
 * The remainder of this code was just pasted from the rest of megahal.c, and
 * modified where necessary to get messages put in the right place, etc.
 */

/*---------------------------------------------------------------------------*/
/*
 *		Function:	Error
 *
 *		Purpose:		Print the specified message to the error file.
 */
static void error(char *title, char *fmt, ...)
{
	va_list argp;
	char stuff[512];

	putlog(LOG_MISC, "*","MegaHAL: Error from \"%s\":", title);

	va_start(argp, fmt);
	vsprintf(stuff, fmt, argp);
	va_end(argp);

	putlog(LOG_MISC, "*", "    %s", stuff);

}

/*---------------------------------------------------------------------------*/

static bool warn(char *title, char *fmt, ...)
{
	va_list argp;
	unsigned char stuff[512];

	putlog(LOG_MISC, "*","MegaHAL: Warning from \"%s\":", title);

	va_start(argp, fmt);
	vsprintf(stuff, fmt, argp);
	va_end(argp);        
                              
	putlog(LOG_MISC, "*", "    %s", stuff);
	return(TRUE);
}

int meg_strcasecmp(const unsigned char *s1, const unsigned char *s2)
{
  while ((*s1) && (*s2) && (egupper(*s1) == egupper(*s2))) {
    s1++;
    s2++;
  }
  return egupper(*s1) - egupper(*s2);
}

/*---------------------------------------------------------------------------*/
/*
 *		Function:	Capitalize
 *
 *		Purpose:		Convert a string to look nice.
 */
static void capitalize(unsigned char *string)
{
	register int i;
	bool start=TRUE;

	for(i=0; i<(int)strlen(string); ++i) {
		if(egisalpha((unsigned char)string[i])) {
			if(start==TRUE) string[i]=egupper((unsigned char)string[i]);
			else string[i]=eglower((unsigned char)string[i]);
			start=FALSE;
		}
		if((i>2)&&(strchr("!.?", string[i-1])!=NULL)&&(isspace(string[i])))
			start=TRUE;
	}
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Upper
 *
 *		Purpose:		Convert a string to its uppercase representation.
 */

static void upper(unsigned char *string)
{
	register unsigned char *dst=string, *src=string;
	int s=0;

	if (!*src) return;

	while (*src && (*src < '\041')) src++;

	while (*src) {
	  if (*src =='\t') *src =' ';
	  if (*src < ' ') {
	    src++;
	    continue;
	  }
	  if (*src == ' ') ++s;
	  else s = 0;
	  *dst = egupper(*src++);
	  if (s < 2) dst++;
	}
	*dst = 0;
	while (--dst > string)
	  if (*dst == ' ') *dst = 0;
	  else break;
}
/*---------------------------------------------------------------------------*/

/*
 *		Function:	Add_WordNew
 *
 *		Purpose:		Add a word to a dictionary, and return the identifier
 *						assigned to the word.  If the word already exists in
 *						the dictionary, then return its current identifier
 *						without adding it again.
 */
static BYTE2 add_wordnew(DICTIONARY *dictionary, STRING word, int position)
{
	register int i;

	/*
	 *		Increase the number of words in the dictionary
	 */
	dictionary->size+=1;

	/*
	 *		Allocate one more entry for the word index
	 */
	if(dictionary->index==NULL) {
		dictionary->index=(BYTE2 *)nmalloc(sizeof(BYTE2)*
		(dictionary->size));
	} else {
		dictionary->index=(BYTE2 *)nrealloc((BYTE2 *)
		(dictionary->index),sizeof(BYTE2)*(dictionary->size));
	}
	if(dictionary->index==NULL) {
		error("add_word", "Unable to nreallocate the index.");
		goto fail;
	}

	/*
	 *		Allocate one more entry for the word array
	 */
	if(dictionary->entry==NULL) {
		dictionary->entry=(STRING *)nmalloc(sizeof(STRING)*(dictionary->size));
	} else {
		dictionary->entry=(STRING *)nrealloc((STRING *)(dictionary->entry),
		sizeof(STRING)*(dictionary->size));
	}
	if(dictionary->entry==NULL) {
		error("add_word", "Unable to nreallocate the dictionary to %d elements.", dictionary->size);
		goto fail;
	}

	/*
	 *		Copy the new word into the word array
	 */
	dictionary->entry[dictionary->size-1].length=word.length;
	dictionary->entry[dictionary->size-1].word=(char *)nmalloc(sizeof(char)*
	(word.length));
	if(dictionary->entry[dictionary->size-1].word==NULL) {
		error("add_word", "Unable to allocate the word.");
		goto fail;
	}
	for(i=0; i<word.length; ++i)
		dictionary->entry[dictionary->size-1].word[i]=word.word[i];

	/*
	 *		Shuffle the word index to keep it sorted alphabetically
	 */
	for(i=(dictionary->size-1); i>position; --i)
		dictionary->index[i]=dictionary->index[i-1];

	/*
	 *		Copy the new symbol identifier into the word index
	 */
	dictionary->index[position]=dictionary->size-1;

	return(dictionary->index[position]);

fail:
	return 0;
}
/*---------------------------------------------------------------------------*/

/*
 *		Function:	Add_Word
 *
 *		Purpose:		Add a word to a dictionary, and return the identifier
 *						assigned to the word.  If the word already exists in
 *						the dictionary, then return its current identifier
 *						without adding it again.
 */
static BYTE2 add_word(DICTIONARY *dictionary, STRING word)
{
	int position;
	bool found;

	/*
	 *		If the word's already in the dictionary, there is no need to add it
	 */
	position=search_dictionary(dictionary, word, &found);
	if(found==TRUE) return(dictionary->index[position]);

	return add_wordnew(dictionary, word, position);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Search_Dictionary
 *
 *		Purpose:		Search the dictionary for the specified word, returning its
 *						position in the index if found, or the position where it
 *						should be inserted otherwise.
 */
static int search_dictionary(DICTIONARY *dictionary, STRING word, bool *find)
{
	int position;
	int min;
	int max;
	int middle;
	int compar;

	/*
	 *		If the dictionary is empty, then obviously the word won't be found
	 */
	if(dictionary->size==0) {
		position=0;
		goto notfound;
	}

	/*
	 *		Initialize the lower and upper bounds of the search
	 */
	min=0;
	max=dictionary->size-1;
	/*
	 *		Search repeatedly, halving the search space each time, until either
	 *		the entry is found, or the search space becomes empty
	 */
	while(TRUE) {
		/*
		 *		See whether the middle element of the search space is greater
		 *		than, equal to, or less than the element being searched for.
		 */
		middle=(min+max)/2;
		compar=wordcmp(word, dictionary->entry[dictionary->index[middle]]);
		/*
		 *		If it is equal then we have found the element.  Otherwise we
		 *		can halve the search space accordingly.
		 */
		if(compar==0) {
			position=middle;
			goto found;
		} else if(compar>0) {
			if(max==middle) {
				position=middle+1;
				goto notfound;
			}
			min=middle+1;
		} else {
			if(min==middle) {
				position=middle;
				goto notfound;
			}
			max=middle-1;
		}
	}

found:
	*find=TRUE;
	return(position);

notfound:
	*find=FALSE;
	return(position);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Find_Word
 *
 *		Purpose:		Return the symbol corresponding to the word specified.
 *						We assume that the word with index zero is equal to a
 *						NULL word, indicating an error condition.
 */
static BYTE2 find_word(DICTIONARY *dictionary, STRING word)
{
	int position;
	bool found;

	position=search_dictionary(dictionary, word, &found);

	if(found==TRUE) return(dictionary->index[position]);
	else return(0);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Find_Word
 *
 *		Purpose:		Return the symbol corresponding to the word specified.
 *						We assume that the word with index zero is equal to a
 *						NULL word, indicating an error condition.
 */
/*
static BYTE2 find_word_complete(DICTIONARY *dictionary, STRING word)
{
	int position;
	bool found;

	position=search_dictionary(dictionary, word, &found);

	if(found==TRUE) return(dictionary->index[position]);
	else return(NOFOUND);
}
*/
/*---------------------------------------------------------------------------*/

/*
 *		Function:	Wordcmp
 *
 *		Purpose:		Compare two words, and return an integer indicating whether
 *						the first word is less than, equal to or greater than the
 *						second word.
 */
static int wordcmp(STRING word1, STRING word2)
{
	register int i;
	int bound;

	bound=MIN(word1.length,word2.length);

	for(i=0; i<bound; ++i)
		if(word1.word[i]!=word2.word[i])
			return((int)(word1.word[i]-word2.word[i]));
/*
		if(egupper((unsigned char)word1.word[i])!=egupper((unsigned char)word2.word[i]))
			return((int)(egupper((unsigned char)word1.word[i])-egupper((unsigned char)word2.word[i])));
*/

	if(word1.length<word2.length) return(-1);
	if(word1.length>word2.length) return(1);


	return(0);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Free_Dictionary
 *
 *		Purpose:		Release the memory consumed by the dictionary.
 */
static void free_dictionary(DICTIONARY *dictionary)
{
	if(dictionary==NULL) return;
	if(dictionary->entry!=NULL) {
		nfree(dictionary->entry);
		dictionary->entry=NULL;
	}
	if(dictionary->index!=NULL) {
		nfree(dictionary->index);
		dictionary->index=NULL;
	}
	dictionary->size=0;
}

/*---------------------------------------------------------------------------*/

static void free_model(MODEL *model)
{
	if(model==NULL) return;
	if(model->forward!=NULL) {
		free_tree(model->forward);
                model->forward=NULL;
	}
	if(model->backward!=NULL) {
		free_tree(model->backward);
                model->backward=NULL;
	}
	if(model->halcontext!=NULL) {
		nfree(model->halcontext);
                model->halcontext=NULL;
	}
	if(model->dictionary!=NULL) {
		free_words(model->dictionary);
		free_dictionary(model->dictionary);
		nfree(model->dictionary);
                model->dictionary=NULL;
	}
	nfree(model);
	model=NULL;  
}

/*---------------------------------------------------------------------------*/

static void free_tree(TREE *tree)
{
	static int level=0;
	register int i;

	if(tree==NULL) return;

	if(tree->tree!=NULL) {
		for(i=0; i<tree->branch; ++i) {
			++level;
			free_tree(tree->tree[i]);
			--level;
		}
		nfree(tree->tree);
/* vd */
		tree->tree=NULL;
	}
	nfree(tree);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Initialize_Dictionary
 *
 *		Purpose:		Add dummy words to the dictionary.
 */
static void initialize_dictionary(DICTIONARY *dictionary)
{
	STRING word={ 7, "<ERROR>" };
	STRING end={ 5, "<FIN>" };

	(void)add_word(dictionary, word);
	(void)add_word(dictionary, end);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	New_Dictionary
 *
 *		Purpose:		Allocate room for a new dictionary.
 */
static DICTIONARY *new_dictionary(void)
{
	DICTIONARY *dictionary=NULL;

	dictionary=(DICTIONARY *)nmalloc(sizeof(DICTIONARY));
	if(dictionary==NULL) {
		error("new_dictionary", "Unable to allocate dictionary.");
		return(NULL);
	}

	dictionary->size=0;
	dictionary->index=NULL;
	dictionary->entry=NULL;

	return(dictionary);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Save_Dictionary
 *
 *		Purpose:		Save a dictionary to the specified file.
 */
static void save_dictionary(FILE *file, DICTIONARY *dictionary)
{
	register int i;

	fwrite(&(dictionary->size), sizeof(BYTE4), 1, file);
	for(i=0; i<dictionary->size; ++i) {
		save_word(file, dictionary->entry[i]);
	}
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Load_Dictionary
 *
 *		Purpose:		Load a dictionary from the specified file.
 */
static void load_dictionary(FILE *file, DICTIONARY *dictionary)
{
	register int i;
	int size;

	fread(&size, sizeof(BYTE4), 1, file);
	for(i=0; i<size; ++i) {
		load_word(file, dictionary);
	}
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Save_Word
 *
 *		Purpose:		Save a dictionary word to a file.
 */
static void save_word(FILE *file, STRING word)
{
	register int i;

	fwrite(&(word.length), sizeof(BYTE1), 1, file);
	for(i=0; i<word.length; ++i)
		fwrite(&(word.word[i]), sizeof(char), 1, file);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Load_Word
 *
 *		Purpose:		Load a dictionary word from a file.
 */
static void load_word(FILE *file, DICTIONARY *dictionary)
{
	register int i;
	STRING word;

	fread(&(word.length), sizeof(BYTE1), 1, file);
	word.word=(char *)nmalloc(sizeof(char)*word.length);
	if(word.word==NULL) {
		error("load_word", "Unable to allocate word");
		return;
	}
	for(i=0; i<word.length; ++i)
		fread(&(word.word[i]), sizeof(char), 1, file);
	add_word(dictionary, word);
	nfree(word.word);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	New_Node
 *
 *		Purpose:		Allocate a new node for the n-gram tree, and initialise
 *						its contents to sensible values.
 */
static TREE *new_node(void)
{
	TREE *node=NULL;

	/*
	 *		Allocate memory for the new node
	 */
	node=(TREE *)nmalloc(sizeof(TREE));
	if(node==NULL) {
		error("new_node", "Unable to allocate the node.");
		goto fail;
	}

	/*
	 *		Initialise the contents of the node
	 */
	node->symbol=0;
	node->usage=0;
	node->count=0;
	node->branch=0;
	node->tree=NULL;

	return(node);

fail:
	if(node!=NULL) nfree(node);
	return(NULL);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	New_Model
 *
 *		Purpose:		Create and initialise a new ngram model.
 */
static MODEL *new_model(int order)
{
	MODEL *model=NULL;

	model=(MODEL *)nmalloc(sizeof(MODEL));
	if(model==NULL) {
		error("new_model", "Unable to allocate model.");
		goto fail;
	}

	model->order=order;
	model->forward=new_node();
	model->backward=new_node();
	model->halcontext=(TREE **)nmalloc(sizeof(TREE *)*(order+2));
	if(model->halcontext==NULL) {
		error("new_model", "Unable to allocate context array.");
		goto fail;
	}
	initialize_context(model);
	model->dictionary=new_dictionary();
	initialize_dictionary(model->dictionary);

	return(model);

fail:
	return(NULL);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Update_Model
 *
 *		Purpose:		Update the model with the specified symbol.
 */
static void update_model(MODEL *model, int symbol)
{
	register int i;

	/*
	 *		Update all of the models in the current context with the specified
	 *		symbol.
	 */
	for(i=(model->order+1); i>0; --i)
		if(model->halcontext[i-1]!=NULL)
			model->halcontext[i]=add_symbol(model->halcontext[i-1], (BYTE2)symbol);

	return;
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Update_Context
 *
 *		Purpose:		Update the context of the model without adding the symbol.
 */
static void update_context(MODEL *model, int symbol)
{
	register int i;

	for(i=(model->order+1); i>0; --i)
		if(model->halcontext[i-1]!=NULL)
			model->halcontext[i]=find_symbol(model->halcontext[i-1], symbol);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Add_Symbol
 *
 *		Purpose:		Update the statistics of the specified tree with the
 *						specified symbol, which may mean growing the tree if the
 *						symbol hasn't been seen in this context before.
 */
static TREE *add_symbol(TREE *tree, BYTE2 symbol)
{
	TREE *node=NULL;

	/*
	 *		Search for the symbol in the subtree of the tree node.
	 */
	node=find_symbol_add(tree, symbol);

	/*
	 *		Increment the symbol counts
	 */
	if((node->count<65535)) {
		node->count+=1;
		tree->usage+=1;
	}

	return(node);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Find_Symbol
 *
 *		Purpose:		Return a pointer to the child node, if one exists, which
 *						contains the specified symbol.
 */
static TREE *find_symbol(TREE *node, int symbol)
{
	register int i;
	TREE *found=NULL;
	bool found_symbol=FALSE;

	/*
	 *		Perform a binary search for the symbol.
	 */
	i=search_node(node, symbol, &found_symbol);
	if(found_symbol==TRUE) found=node->tree[i];

	return(found);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Find_Symbol_Add
 *
 *		Purpose:		This function is conceptually similar to find_symbol,
 *						apart from the fact that if the symbol is not found,
 *						a new node is automatically allocated and added to the
 *						tree.
 */
static TREE *find_symbol_add(TREE *node, int symbol)
{
	register int i;
	TREE *found=NULL;
	bool found_symbol=FALSE;

	/*
	 *		Perform a binary search for the symbol.  If the symbol isn't found,
	 *		attach a new sub-node to the tree node so that it remains sorted.
	 */
	i=search_node(node, symbol, &found_symbol);
	if(found_symbol==TRUE) {
		found=node->tree[i];
	} else {
		found=new_node();
		found->symbol=symbol;
		add_node(node, found, i);
	}

	return(found);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Add_Node
 *
 *		Purpose:		Attach a new child node to the sub-tree of the tree
 *						specified.
 */
static void add_node(TREE *tree, TREE *node, int position)
{
	register int i;

	/*
	 *		Allocate room for one more child node, which may mean allocating
	 *		the sub-tree from scratch.
	 */
	if(tree->tree==NULL) {
		tree->tree=(TREE **)nmalloc(sizeof(TREE *)*(tree->branch+1));
	} else {
		tree->tree=(TREE **)nrealloc((TREE **)(tree->tree),sizeof(TREE *)*
		(tree->branch+1));
	}
	if(tree->tree==NULL) {
		error("add_node", "Unable to nreallocate subtree.");
		return;
	}

	/*
	 *		Shuffle the nodes down so that we can insert the new node at the
	 *		subtree index given by position.
	 */
	for(i=tree->branch; i>position; --i)
		tree->tree[i]=tree->tree[i-1];

	/*
	 *		Add the new node to the sub-tree.
	 */
	tree->tree[position]=node;
	tree->branch+=1;
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Search_Node
 *
 *		Purpose:		Perform a binary search for the specified symbol on the
 *						subtree of the given node.  Return the position of the
 *						child node in the subtree if the symbol was found, or the
 *						position where it should be inserted to keep the subtree
 *						sorted if it wasn't.
 */
static int search_node(TREE *node, int symbol, bool *found_symbol)
{
	register int position;
	int min;
	int max;
	int middle;
	int compar;

	/*
	 *		Handle the special case where the subtree is empty.
	 */
	if(node->branch==0) {
		position=0;
		goto notfound;
	}

	/*
	 *		Perform a binary search on the subtree.
	 */
	min=0;
	max=node->branch-1;
	while(TRUE) {
		middle=(min+max)/2;
		compar=symbol-node->tree[middle]->symbol;
		if(compar==0) {
			position=middle;
			goto found;
		} else if(compar>0) {
			if(max==middle) {
				position=middle+1;
				goto notfound;
			}
			min=middle+1;
		} else {
			if(min==middle) {
				position=middle;
				goto notfound;
			}
			max=middle-1;
		}
	}

found:
	*found_symbol=TRUE;
	return(position);

notfound:
	*found_symbol=FALSE;
	return(position);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Initialize_Context
 *
 *		Purpose:		Set the context of the model to a default value.
 */
static void initialize_context(MODEL *model)
{
	register int i;

	for(i=0; i<=model->order; ++i) model->halcontext[i]=NULL;
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Learn
 *
 *		Purpose:		Learn from the user's input.
 */
static void learn(MODEL *model, DICTIONARY *words)
{
	register int i;
	BYTE2 symbol;

	/*
	 *		We only learn from inputs which are long enough
	 */
	if(words->size<=(model->order)) {
	  if(words->size<3) return;
	  while(words->size<=(model->order)) {
	    if(words->entry==NULL)
		words->entry=(STRING *)nmalloc((words->size+1)*sizeof(STRING));
	    else
		words->entry=(STRING *)nrealloc(words->entry, (words->size+1)*sizeof(STRING));

	    if(words->entry==NULL) {
		error("learn", "Unable to reallocate dictionary");
		return;
	    }
	    words->entry[words->size].length=1;
	    words->entry[words->size].word="\t";
	    words->size+=1;
	  }	
	}

	/*
	 *		Train the model in the forwards direction.  Start by initializing
	 *		the context of the model.
	 */
	initialize_context(model);
	model->halcontext[0]=model->forward;
	for(i=0; i<words->size; ++i) {
		/*
		 *		Add the symbol to the model's dictionary if necessary, and then
		 *		update the forward model accordingly.
		 */
		symbol=add_word(model->dictionary, words->entry[i]);
		update_model(model, symbol);
	}
	/*
	 *		Add the sentence-terminating symbol.
	 */
	update_model(model, 1);

	/*
	 *		Train the model in the backwards direction.  Start by initializing
	 *		the context of the model.
	 */
	initialize_context(model);
	model->halcontext[0]=model->backward;
	for(i=words->size-1; i>=0; --i) {
		/*
		 *		Find the symbol in the model's dictionary, and then update
		 *		the backward model accordingly.
		 */
		symbol=find_word(model->dictionary, words->entry[i]);
		update_model(model, symbol);
	}
	/*
	 *		Add the sentence-terminating symbol.
	 */
	update_model(model, 1);

	return;
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Train
 *
 *		Purpose:	 	Infer a MegaHAL brain from the contents of a text file.
 */
static void train(MODEL *model, char *filename)
{
	FILE *file;
	unsigned char buffer[INBUFSIZE];
	DICTIONARY *words=NULL;
	int length;

	if(filename==NULL) return;

	file=openfile(filename, "r");
	if(file==NULL) {
	  error("train","Unable to find the personality %s%s", megfileprefix, filename);
	  return;
	}

	fseek(file, 0, 2);
	length=ftell(file);
	rewind(file);

	words=new_dictionary();

	while(!feof(file)) {

		if(fgets(buffer, INBUFSIZE, file)==NULL) break;
		if(buffer[0]=='#') continue;

		buffer[strlen(buffer)-1]='\0';
		upper(buffer);
		if ((make_words(buffer, words)) && (meg_badword) ) continue;
		learn(model, words);
	}

	free_dictionary(words);
	fclose(file);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Show_Dictionary
 *
 *		Purpose:		Display the dictionary for training purposes.
 */
static void show_dictionary(DICTIONARY *dictionary)
{
	register int i;
	register int j;
	FILE *file;

	file=openfile(".dic", "w");
	if(file==NULL) {
		warn("show_dictionary", "Unable to open file %s%s",megfileprefix, ".dic");
		return;
	}

	for(i=0; i<dictionary->size; ++i) {
		for(j=0; j<dictionary->entry[i].length; ++j)
			fprintf(file, "%c", dictionary->entry[i].word[j]);
		fprintf(file, "\n");
	}

	fclose(file);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Save_Model
 *
 *		Purpose:		Save the current state to a MegaHAL brain file.
 */
static void save_model(char *modelname, MODEL *model)
{
	FILE *file;
	static char *filename=NULL;
	static char srcfilename[255];
	static char dstfilename[255];
	
	sprintf(srcfilename, "%s%s%s%s", directory, SEP,megfileprefix,modelname);
	sprintf(dstfilename, "%s~bak", srcfilename);

	show_dictionary(model->dictionary);
	putlog(LOG_MISC, "*", "Backing up %s%s file to %s%s~bak...",megfileprefix,modelname,megfileprefix,modelname);
	copyfile(srcfilename, dstfilename);

	filename = modelname;
	file=openfile(filename, "wb");
	if(file==NULL) {
		warn("save_model", "Unable to open file `%s%s'",megfileprefix , filename);
		return;
	}

	fwrite(COOKIE, sizeof(char), strlen(COOKIE), file);
	fwrite(&(model->order), sizeof(BYTE1), 1, file);
	save_tree(file, model->forward);
	save_tree(file, model->backward);
	save_dictionary(file, model->dictionary);
	fclose(file);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Save_Tree
 *
 *		Purpose:		Save a tree structure to the specified file.
 */
static void save_tree(FILE *file, TREE *node)
{
	static int level=0;
	register int i;

	fwrite(&(node->symbol), sizeof(BYTE2), 1, file);
	fwrite(&(node->usage), sizeof(BYTE4), 1, file);
	fwrite(&(node->count), sizeof(BYTE2), 1, file);
	fwrite(&(node->branch), sizeof(BYTE2), 1, file);

	for(i=0; i<node->branch; ++i) {
		++level;
		save_tree(file, node->tree[i]);
		--level;
	}
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Load_Tree
 *
 *		Purpose:		Load a tree structure from the specified file.
 */
static void load_tree(FILE *file, TREE *node)
{
	static int level=0;
	register int i;

	fread(&(node->symbol), sizeof(BYTE2), 1, file);
	fread(&(node->usage), sizeof(BYTE4), 1, file);
	fread(&(node->count), sizeof(BYTE2), 1, file);
	fread(&(node->branch), sizeof(BYTE2), 1, file);

	if(node->branch==0) return;

	node->tree=(TREE **)nmalloc(sizeof(TREE *)*(node->branch));
	if(node->tree==NULL) {
		error("load_tree", "Unable to allocate subtree");
		return;
	}

	for(i=0; i<node->branch; ++i) {
		node->tree[i]=new_node();
		++level;
		load_tree(file, node->tree[i]);
		--level;
	}
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Load_Model
 *
 *		Purpose:		Load a model into memory.
 */
static bool load_model(char *filename, MODEL *model)
{
	FILE *file;
	unsigned char cookie[16];
	
	if(filename==NULL) return(FALSE);

	file=openfile(filename, "rb");
	if(file==NULL) {
		warn("load_model", "Unable to open file %s%s", megfileprefix,filename);
		return(FALSE);
	}

	fread(cookie, sizeof(char), strlen(COOKIE), file);
	if(strncmp(cookie, COOKIE, strlen(COOKIE))!=0) {
	  if(strncmp(cookie, COOKIE8, strlen(COOKIE8))!=0) {
		warn("load_model", "File `%s%s' is not a MegaHAL brain",megfileprefix ,filename);
		goto fail;
	  }
	}

	fread(&(model->order), sizeof(BYTE1), 1, file);
	if (model->order != order) {
	  model->halcontext=(TREE **)nrealloc(model->halcontext,sizeof(TREE *)*(model->order+2));
	  if(model->halcontext==NULL) {
		error("new_model", "Unable to allocate context array.");
		goto fail;
	  }
	  initialize_context(model);
	}
	load_tree(file, model->forward);
	load_tree(file, model->backward);
	load_dictionary(file, model->dictionary);

	fclose(file);

	if (model->order != order) {
	  save_msg(model);
	  free_model(model);
	  model=new_model(order);
	  filename = ".msg";
	  train(model, filename);
	}
	return(TRUE);
fail:
	fclose(file);
	return(FALSE);
}
/*---------------------------------------------------------------------------*/

static unsigned char *find_mynicks(unsigned char *input)
{
        unsigned char *intext=NULL;
	int offset=0;
	int position;
	bool found;
	STRING wordsentry;

	if (mynewsplit(inbuffer,input,INBUF) < minlennick) return NULL;

	while(1) {
		inbuffer[offset]=egupper(inbuffer[offset]);
		if(boundary(inbuffer, offset)) {
			wordsentry.length=offset;
			wordsentry.word=inbuffer;

			position=search_dictionary(mynicks, wordsentry, &found);

			if(found==FALSE) return NULL;

			input+=offset;
			if (*input) input+=1;

			while(*input == ' ') input+=1;

                        intext=input;
			break;
		} else {
			++offset;
		}
	}

   return intext;
}

/*---------------------------------------------------------------------------*/

/*
 *    Function:   Make_Words
 *
 *    Purpose:    Break a string into an array of words.
 */
static bool make_words(unsigned char *input, DICTIONARY *words)
{
	int offset=0;
	bool ret = FALSE;
	/*
	 *		Clear the entries in the dictionary
	 */

	free_dictionary(words);

	/*
	 *		If the string is empty then do nothing, for it contains no words.
	 */
	if(strlen(input)==0) return FALSE;

	/*
	 *		Loop forever.
	 */
	while(1) {

		/*
		 *		If the current character is of the same type as the previous
		 *		character, then include it in the word.  Otherwise, terminate
		 *		the current word.
		 */
		if(boundary(input, offset)) {
			/*
			 *		Add the word to the dictionary
			 */
			if(words->entry==NULL)
				words->entry=(STRING *)nmalloc((words->size+1)*sizeof(STRING));
			else
				words->entry=(STRING *)nrealloc(words->entry, (words->size+1)*sizeof(STRING));

			if(words->entry==NULL) {
				error("make_words", "Unable to nreallocate dictionary");
				return FALSE;
			}

			words->entry[words->size].length=offset;
			words->entry[words->size].word=input;
			words->size+=1;

			if(offset==(int)strlen(input)) break;
			input+=offset;
			offset=0;
		} else {
			++offset;
		}
	}
	if ((meg_badword!=0) || (meg_noswapbadword==0)) {
	  if (swap_badwords(words)) ret = TRUE;
	}
	/*
	 *		If the last word isn't punctuation, then replace it with a
	 *		full-stop character.
	 */
	if(egisalnum(words->entry[words->size-1].word[0])) {
		if(words->entry==NULL)
			words->entry=(STRING *)nmalloc((words->size+1)*sizeof(STRING));
		else
			words->entry=(STRING *)nrealloc(words->entry, (words->size+1)*sizeof(STRING));
		if(words->entry==NULL) {
			error("make_words", "Unable to nreallocate dictionary");
			return ret;
		}

		words->entry[words->size].length=1;
		words->entry[words->size].word=".";
		++words->size;
	}
	else if(strchr("!.?)(", words->entry[words->size-1].word[words->entry[words->size-1].length-1])==NULL) {
	  if(words->entry==NULL)
		words->entry=(STRING *)nmalloc((words->size+1)*sizeof(STRING));
	  else
		words->entry=(STRING *)nrealloc(words->entry, (words->size+1)*sizeof(STRING));

	  if(words->entry==NULL) {
		error("make_words", "Unable to reallocate dictionary");
		return ret;
	  }
	  words->entry[words->size].length=1;
	  words->entry[words->size].word=".";
          words->size+=1;
	}
   return ret;
}

/*---------------------------------------------------------------------------*/
/*
 *		Function:	Boundary
 *
 *		Purpose:		Return whether or not a word boundary exists in a string
 *						at the specified location.
 */
static bool boundary(unsigned char *string, int position)
{
	if(position==0)
		return(FALSE);

	if(position==(int)strlen(string))
		return(TRUE);

	if(
		(string[position]=='\'')&&
		(egisalpha(string[position-1])!=0)&&
		(egisalpha(string[position+1])!=0)
	)
		return(FALSE);

	if(
		(position>1)&&
		(string[position-1]=='\'')&&
		(egisalpha(string[position-2])!=0)&&
		(egisalpha(string[position])!=0)
	)
		return(FALSE);

	if(
		(egisalpha(string[position])!=0)&&
		(egisalpha(string[position-1])==0)
	)
		return(TRUE);

	if(
		(egisalpha(string[position])==0)&&
		(egisalpha(string[position-1])!=0)
	)
		return(TRUE);

	if(isdigit(string[position])!=isdigit(string[position-1]))
		return(TRUE);

	return(FALSE);
}

/*---------------------------------------------------------------------------*/ 
/*
 *		Function:	Make_Greeting
 *
 *		Purpose:		Put some special words into the dictionary so that the
 *						program will respond as if to a new judge.
 */
static void make_greeting(DICTIONARY *words)
{
    if(grt->size>0) {
      free_dictionary(words);
      (void)add_word(words, grt->entry[rnd(grt->size)]);
    }
}

/*---------------------------------------------------------------------------*/
/*
 *    Function:   Generate_Reply
 *
 *    Purpose:    Take a string of user input and return a string of output
 *                which may vaguely be construed as containing a reply to
 *                whatever is in the input string.
 */
static unsigned char *generate_reply(MODEL *model, DICTIONARY *words)
{
	static DICTIONARY *dummy=NULL;
	DICTIONARY *replywords;
	DICTIONARY *keywords;
	float surprise;
	float max_surprise;
	unsigned char *output;
	static unsigned char *output_none=NULL;
	int count;
	int basetime;

	/*
	 *		Create an array of keywords from the words in the user's input
	 */
	keywords=make_keywords(model, words);

	/*
	 *		Make sure some sort of reply exists
	 */
	if(output_none==NULL) {
		output_none=nmalloc(40);
		if(output_none!=NULL)
			strcpy(output_none, "I don't know enough to answer you yet!");
	}
	output=output_none;
	if(dummy==NULL) dummy=new_dictionary();
	replywords=reply(model, dummy);
	if(dissimilar(words, replywords)==TRUE) output=make_output(replywords);

	/*
	 *		Loop for the specified waiting period, generating and evaluating
	 *		replies
	 */
	max_surprise=(float)-1.0;
/*	count=0; 
*/
	count=rnd(148+words->size);

	basetime=time(NULL); 
	do {    
		replywords=reply(model, keywords);
		surprise=evaluate_reply(model, keywords, replywords);
/*		++count; 
*/
		--count;
		if((surprise>max_surprise)&&(dissimilar(words, replywords)==TRUE)) {
			max_surprise=surprise;
			output=make_output(replywords);
		}
		if (!count) break;
	} while((time(NULL)-basetime)<timeout);

	/*
	 *		Return the best answer we generated
	 */
	return(output);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Dissimilar
 *
 *		Purpose:		Return TRUE or FALSE depending on whether the dictionaries
 *						are the same or not.
 */
static bool dissimilar(DICTIONARY *words1, DICTIONARY *words2)
{
	register int i;

	if(words1->size!=words2->size) return(TRUE);
	for(i=0; i<words1->size; ++i)
		if(wordcmp(words1->entry[i], words2->entry[i])!=0) return(TRUE);
	return(FALSE);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Make_Keywords
 *
 *		Purpose:		Put all the interesting words from the user's input into
 *						a keywords dictionary, which will be used when generating
 *						a reply.
 */
static DICTIONARY *make_keywords(MODEL *model, DICTIONARY *words)
{
	static DICTIONARY *keys=NULL;
	register int i;
	int c, position;

	if(keys==NULL) keys=new_dictionary();

	for(i=0; i<keys->size; ++i) nfree(keys->entry[i].word);
	free_dictionary(keys);

	for(i=0; i<words->size; ++i) {
		/*
		 *		Find the symbol ID of the word.  If it doesn't exist in
		 *		the model, or if it begins with a non-alphanumeric
		 *		character, or if it is in the exclusion array, then
		 *		skip over it.
		 */
		c=0;
		position = find_word(swp->dictionary,words->entry[i]);
		if(position) {
			add_key(model, keys, swp->to[position]);
			++c;
		}

		if(c==0) add_key(model, keys, words->entry[i]);
	}

	if(keys->size>0) for(i=0; i<words->size; ++i) {

		c=0;
		position = find_word(swp->dictionary,words->entry[i]);
		if(position) {
			add_aux(model, keys, swp->to[position]);
			++c;
		}
		if(c==0) add_aux(model, keys, words->entry[i]);
	}

	return(keys);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Add_Key
 *
 *		Purpose:		Add a word to the keyword dictionary.
 */
static void add_key(MODEL *model, DICTIONARY *keys, STRING word)
{
	int symbol;

	symbol=find_word(model->dictionary, word);
	if(symbol==0) return;
	if(egisalnum(word.word[0])==0) return;
	symbol=find_word(ban, word);
	if(symbol!=0) return;
	symbol=find_word(aux, word);
	if(symbol!=0) return;

	add_word(keys, word);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Add_Aux
 *
 *		Purpose:		Add an auxilliary keyword to the keyword dictionary.
 */
static void add_aux(MODEL *model, DICTIONARY *keys, STRING word)
{
	int symbol;

	symbol=find_word(model->dictionary, word);
	if(symbol==0) return;
	if(egisalnum(word.word[0])==0) return;
	symbol=find_word(aux, word);
	if(symbol==0) return;

	add_word(keys, word);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Reply
 *
 *		Purpose:		Generate a dictionary of reply words appropriate to the
 *						given dictionary of keywords.
 */
static DICTIONARY *reply(MODEL *model, DICTIONARY *keys)
{
	static DICTIONARY *replies=NULL;
	register int i;
	int symbol;
	bool start=TRUE;

	if(replies==NULL) replies=new_dictionary();
	free_dictionary(replies);

	/*
	 *		Start off by making sure that the model's context is empty.
	 */
	initialize_context(model);
	model->halcontext[0]=model->forward;
	used_key=FALSE;

	/*
	 *		Generate the reply in the forward direction.
	 */
	while(TRUE) {
		/*
		 *		Get a random symbol from the current context.
		 */
		if(start==TRUE) symbol=seed(model, keys);
		else symbol=babble(model, keys, replies);
		if((symbol==0)||(symbol==1)) break;
		start=FALSE;

		/*
		 *		Append the symbol to the reply dictionary.
		 */
		if(replies->entry==NULL)
			replies->entry=(STRING *)nmalloc((replies->size+1)*sizeof(STRING));
		else
			replies->entry=(STRING *)nrealloc(replies->entry, (replies->size+1)*sizeof(STRING));
		if(replies->entry==NULL) {
			error("reply", "Unable to nreallocate dictionary");
			return(NULL);
		}

		replies->entry[replies->size].length=
			model->dictionary->entry[symbol].length;
		replies->entry[replies->size].word=
			model->dictionary->entry[symbol].word;
		replies->size+=1;

		/*
		 *		Extend the current context of the model with the current symbol.
		 */
		update_context(model, symbol);
	}

	/*
	 *		Start off by making sure that the model's context is empty.
	 */
	initialize_context(model);
	model->halcontext[0]=model->backward;

	/*
	 *		Re-create the context of the model from the current reply
	 *		dictionary so that we can generate backwards to reach the
	 *		beginning of the string.
	 */
	if(replies->size>0) for(i=MIN(replies->size-1, model->order); i>=0; --i) {
		symbol=find_word(model->dictionary, replies->entry[i]);
		update_context(model, symbol);
	}

	/*
	 *		Generate the reply in the backward direction.
	 */
	while(TRUE) {
		/*
		 *		Get a random symbol from the current context.
		 */
		symbol=babble(model, keys, replies);
		if((symbol==0)||(symbol==1)) break;

		/*
		 *		Prepend the symbol to the reply dictionary.
		 */
		if(replies->entry==NULL)
			replies->entry=(STRING *)nmalloc((replies->size+1)*sizeof(STRING));
		else
			replies->entry=(STRING *)nrealloc(replies->entry, (replies->size+1)*sizeof(STRING));
		if(replies->entry==NULL) {
			error("reply", "Unable to nreallocate dictionary");
			return(NULL);
		}

		/*
		 *		Shuffle everything up for the prepend.
		 */
		for(i=replies->size; i>0; --i) {
			replies->entry[i].length=replies->entry[i-1].length;
			replies->entry[i].word=replies->entry[i-1].word;
		}

		replies->entry[0].length=model->dictionary->entry[symbol].length;
		replies->entry[0].word=model->dictionary->entry[symbol].word;
		replies->size+=1;

		/*
		 *		Extend the current context of the model with the current symbol.
		 */
		update_context(model, symbol);
	}

	return(replies);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Evaluate_Reply
 *
 *		Purpose:		Measure the average surprise of keywords relative to the
 *						language model.
 */
static float evaluate_reply(MODEL *model, DICTIONARY *keys, DICTIONARY *words)
{

	register int i;
	register int j;
	int symbol;
	float probability;
	int count;
	float entropy=(float)0.0;
	TREE *node;
	int num=0;

	if(words->size<=0) return((float)0.0);

	initialize_context(model);
	model->halcontext[0]=model->forward;
	for(i=0; i<words->size; ++i) {
		symbol=find_word(model->dictionary, words->entry[i]);

		if(find_word(keys, words->entry[i])!=0) {
			probability=(float)0.0;
			count=0;
			++num;
			for(j=0; j<model->order; ++j) if(model->halcontext[j]!=NULL) {

				node=find_symbol(model->halcontext[j], symbol);
				probability+=(float)(node->count)/
					(float)(model->halcontext[j]->usage);
				++count;

			}

			if(count>0.0) entropy-=(float)log(probability/(float)count);
		}

		update_context(model, symbol);
	}

	initialize_context(model);
	model->halcontext[0]=model->backward;
	for(i=words->size-1; i>=0; --i) {
		symbol=find_word(model->dictionary, words->entry[i]);

		if(find_word(keys, words->entry[i])!=0) {
			probability=(float)0.0;
			count=0;
			++num;
			for(j=0; j<model->order; ++j) if(model->halcontext[j]!=NULL) {

				node=find_symbol(model->halcontext[j], symbol);
				probability+=(float)(node->count)/
					(float)(model->halcontext[j]->usage);
				++count;

			}

			if(count>0.0) entropy-=(float)log(probability/(float)count);
		}

		update_context(model, symbol);
	}

	if(num>=8) entropy/=(float)sqrt(num-1);
	if(num>=16) entropy/=(float)num;

	return(entropy);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Make_Output
 *
 *		Purpose:		Generate a string from the dictionary of reply words.
 */
static unsigned char *make_output(DICTIONARY *words)
{
	static unsigned char *output=NULL;
	register int i;
	register int j;
	int length;
	static unsigned char *output_none=NULL;

	if(output_none==NULL) output_none=nmalloc(40);

	if(output==NULL) {
		output=(unsigned char *)nmalloc(sizeof(unsigned char));
		if(output==NULL) {
			error("make_output", "Unable to allocate output");
			return(output_none);
		}
	}

	if(words->size==0) {
		if(output_none!=NULL)
			strcpy(output_none, "I am utterly speechless!");
		return(output_none);
	}

	length=1;
	for(i=0; i<words->size; ++i) length+=(words->entry[i].length + 1);

	output=(unsigned char *)nrealloc(output, sizeof(unsigned char)*length);
	if(output==NULL) {
		error("make_output", "Unable to nreallocate output.");
		if(output_none!=NULL)
			strcpy(output_none, "I forgot what I was going to say!");
		return(output_none);
	}

	length=0;
	for(i=0; i<words->size; ++i) {
	  if((i>0)&&(strchr(charspaces, words->entry[i].word[0])==NULL)&&(strchr(charspaces, output[(length-1)])==NULL))
	    output[length++]='\040';
	  for(j=0; j<words->entry[i].length; ++j) {
	    if(words->entry[i].word[j] == '\t') {
	      output[length++]='\0';
	      break;
	    }
	    else
	    output[length++]=words->entry[i].word[j];
	  }
	}
	output[length]='\0';

	return(output);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Babble
 *
 *		Purpose:		Return a random symbol from the current context, or a
 *						zero symbol identifier if we've reached either the
 *						start or end of the sentence.  Select the symbol based
 *						on probabilities, favouring keywords.  In all cases,
 *						use the longest available context to choose the symbol.
 */
static int babble(MODEL *model, DICTIONARY *keys, DICTIONARY *words)
{
	TREE *node=NULL;
	register int i;
	int count;
	int symbol=0;

	/*
	 *		Select the longest available context.
	 */
	for(i=0; i<=model->order; ++i)
		if(model->halcontext[i]!=NULL)
			node=model->halcontext[i];

	if(node->branch==0) return 0;

	/*
	 *		Choose a symbol at random from this context.
	 */
	i=rnd(node->branch);
	count=rnd(node->usage);
	while(count>=0) {
		/*
		 *		If the symbol occurs as a keyword, then use it.  Only use an
		 *		auxilliary keyword if a normal keyword has already been used.
		 */
		symbol=node->tree[i]->symbol;

		if(
			(find_word(keys, model->dictionary->entry[symbol])!=0)&&
			((used_key==TRUE)||
			(find_word(aux, model->dictionary->entry[symbol])==0))&&
			(word_exists(words, model->dictionary->entry[symbol])==FALSE)
		) {
			used_key=TRUE;
			break;
		}
		count-=node->tree[i]->count;
		i=(i>=(node->branch-1))?0:i+1;
	}

	return symbol;
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Word_Exists
 *
 *		Purpose:		A silly brute-force searcher for the reply string.
 */
static bool word_exists(DICTIONARY *dictionary, STRING word)
{
	register int i;

	for(i=0; i<dictionary->size; ++i)
		if(wordcmp(dictionary->entry[i], word)==0)
			return(TRUE);
	return(FALSE);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Seed
 *
 *		Purpose:		Seed the reply by guaranteeing that it contains a
 *						keyword, if one exists.
 */
static int seed(MODEL *model, DICTIONARY *keys)
{
	register int i;
	int symbol;
	int stop;

	/*
	 *		Fix, thanks to Mark Tarrabain
	 */
	if(model->halcontext[0]->branch==0) symbol=0;
	else symbol=model->halcontext[0]->tree[rnd(model->halcontext[0]->branch)]->symbol;

	if(keys->size>0) {
		i=rnd(keys->size);
		stop=i;
		while(TRUE) {
			if(
				(find_word(model->dictionary, keys->entry[i])!=0)&&
				(find_word(aux, keys->entry[i])==0)
			) {
				symbol=find_word(model->dictionary, keys->entry[i]);
				return(symbol);
			}
			++i;
			if(i==keys->size) i=0;
			if(i==stop) return(symbol);
		}
	}

	return(symbol);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	New_Swap
 *
 *		Purpose:		Allocate a new swap structure.
 */
static SWAP *new_swap(void)
{
	SWAP *list;

	list=(SWAP *)nmalloc(sizeof(SWAP));
	if(list==NULL) {
		error("new_swap", "Unable to allocate swap");
		return(NULL);
	}
	list->dictionary=new_dictionary();
	list->to=NULL;

	return(list);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Add_Swap
 *
 *		Purpose:		Add a new entry to the swap structure.
 */
static void add_swap(SWAP *list, unsigned char *s, unsigned char *d)
{
	register int i;
	int position;
	bool found;
	STRING from;
	BYTE2 index;

	from.length=strlen(s);
	from.word = s;

	position=search_dictionary(list->dictionary, from, &found);
	if(found==TRUE) return;

	index = add_wordnew(list->dictionary, from, position);
	

	if(list->to==NULL) {
		list->to=(STRING *)nmalloc(sizeof(STRING));
		if(list->to==NULL) {
			error("add_swap", "Unable to allocate list->to");
			return;
		}
	}

	list->to=(STRING *)nrealloc(list->to, sizeof(STRING)*(list->dictionary->size));
	if(list->to==NULL) {
		error("add_swap", "Unable to nreallocate to");
		return;
	}

	list->to[list->dictionary->size-1].length=strlen(d);
	list->to[list->dictionary->size-1].word=(char *)nmalloc(sizeof(char)*
	(list->to[list->dictionary->size-1].length));
	if(list->to[list->dictionary->size-1].word==NULL) {
		error("add_swap", "Unable to allocate the word.");
		return;
	}
	for(i=0; i<list->to[list->dictionary->size-1].length; ++i)
		list->to[list->dictionary->size-1].word[i]=d[i];

}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Initialize_Swap
 *
 *		Purpose:		Read a swap structure from a file.
 */
static SWAP *initialize_swap(char *filename, bool trans)
{
	SWAP *list;
	FILE *file=NULL;
	unsigned char buffer[INBUFSIZE];
	unsigned char *from, *transfrom;
	unsigned char *to;

	list=new_swap();

	if(filename==NULL) return(list);

	file=openfile(filename, "r");
	if(file==NULL) return(list);

	while(!feof(file)) {

		if(fgets(buffer, INBUFSIZE, file)==NULL) break;
		if(buffer[0]=='#') continue;
		upper(buffer);
		from=strtok(buffer, "\t ");
		to=strtok(NULL, "\t \r\n#");
	
		if ((from==NULL) || (from[0]==0)) continue;
		if ((to==NULL) || (to[0]==0)) {
			to="!!!";
		}

		add_swap(list, from, to);
		if (trans) {
		  transfrom = totranslit(from);
		  add_swap(list, transfrom, to);
		}
	}

	fclose(file);
	return(list);
}

/*---------------------------------------------------------------------------*/

static void free_swap(SWAP *swap)
{
	register int i;

	if(swap==NULL) return;

	if(swap->to!=NULL) {
	  for(i=0; i<swap->dictionary->size; ++i) free_word(&(swap->to[i]));
	  nfree(swap->to);
	  swap->to=NULL;
	}
	if(swap->dictionary!=NULL) {
		free_words(swap->dictionary);
		free_dictionary(swap->dictionary);
		nfree(swap->dictionary);
                swap->dictionary=NULL;
	}
	nfree(swap);
	swap=NULL;
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Initialize_List
 *
 *		Purpose:		Read a dictionary from a file.
 */
static DICTIONARY *initialize_list(char *filename)
{
	DICTIONARY *list;
	FILE *file=NULL;
	STRING word;
	unsigned char *string;
	unsigned char buffer[INBUFSIZE];

	list=new_dictionary();

	if(filename==NULL) return(list);

	file=openfile(filename, "r");
	if(file==NULL) return(list);

	word.word="\n";
	word.length=1;
	add_word(list, word);

	while(!feof(file)) {
		if(fgets(buffer, INBUFSIZE, file)==NULL) break;
		if(buffer[0]=='#') continue;
		upper(buffer);
		string=strtok(buffer, "\t \r\n#");

		if((string!=NULL)&&(strlen(string)>0)) {
			word.length=strlen(string);
			word.word=mystrdup(buffer);
			add_word(list, word);
			nfree(word.word);
		}
	}

	fclose(file);
	return(list);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Rnd
 *
 *		Purpose:		Return a random integer between 0 and range-1.
 */
static int rnd(int range)
{
	static bool flag=FALSE;

	if(flag==FALSE) {
		srand48(time(NULL));
	}
	flag=TRUE;
	return(floor(drand48()*(double)(range)));
}

/*---------------------------------------------------------------------------*/
static void unload_personality(MODEL **model)
{
	save_model(".brn", *model);
	free_model(*model);
	free_alldic();

}
static void free_alldic(void)
{
	register int i;

	Context;
	free_words(ban);
	if(ban!=NULL) {
	  free_dictionary(ban);
	  nfree(ban);
	  ban=NULL; 
	}
	Context;
	free_words(aux);
	if(aux!=NULL) {
	  free_dictionary(aux);
	  nfree(aux);
	  aux=NULL; 
	}
	Context;
	free_words(grt);
	if(grt!=NULL) {
	  free_dictionary(grt);
	  nfree(grt);
	  grt=NULL; 
	}
	Context;
	free_words(mynicks);
	if(mynicks!=NULL) {
	  free_dictionary(mynicks);
	  nfree(mynicks);
	  mynicks=NULL; 
	}
	Context;
	free_words(key);
	if(key!=NULL) {
	  free_dictionary(key);
	  nfree(key);
	  key=NULL; 
	}
	Context;
	free_words(hello);
	if(hello!=NULL) {
	  free_dictionary(hello);
	  nfree(hello);
	  hello=NULL; 
	}
	Context;
	free_swap(swp);
	Context;
	free_swap(mat);

	Context;
	for(i=0;i<128;i++) {
	  if((transtab[i] != NULL) && (transtab[i] != nullchar)){
	    nfree(transtab[i]);
	    transtab[i] = NULL;
	  }
	}

	Context;
	free_users(usr);
	if(usr!=NULL) {
	  nfree(usr);
	  usr=NULL; 
	}
}

static void appendload(MODEL **model)
{
	static char *filename=".trn";

	train(*model, filename);

	return;
}
static void load_personality(MODEL **model)
{
	static char *filename=NULL;
	Context;

	/*
	 *		Free the current personality
	 */
	free_model(*model);

	free_alldic();

	initialize_codepage();
	initialize_translit();

	/*
	 *		Create a language model.
	 */
	*model=new_model(order);
	filename = ".mat";
	mat=initialize_swap(filename, TRUE);
/*	save_swap(mat,".swpmat"); */

	/*
	 *		Train the model on a text if one exists
	 */
	filename = ".brn";
	if(load_model(filename, *model)==FALSE) {
		filename = ".trn";
		train(*model, filename);
	}

	/*
	 *		Read a dictionary containing banned keywords, auxiliary keywords,
	 *		greeting keywords and swap keywords
	 */
	filename = ".ban";
	ban=initialize_list(filename);
	filename = ".aux";
	aux=initialize_list(filename);
	filename = ".grt";
	grt=initialize_list(filename);
	filename = ".swp";
	swp=initialize_swap(filename, FALSE);
	filename = ".nick";
	mynicks=initialize_list(filename);
	if(mynicks->size==0) {
	   warn("load_personality","My Nicks is not found, not found file \"%s.nick\" or file is free.",megfileprefix);
	}
	filename = ".usr";
	usr=initialize_users(filename);
	filename = ".key";
	key=initialize_list(filename);
	filename = ".hello";
	hello=initialize_list(filename);
}

/*---------------------------------------------------------------------------*/

static void change_personality(DICTIONARY *command, int position, MODEL **model)
{
	directory = megpatch;
	last = mystrdup(directory);

/*
	if(last!=NULL) { nfree(last); last=NULL; }
	if(directory!=NULL) last=mystrdup(directory);
	else directory=(char *)nmalloc(sizeof(char)*1);
	if(directory==NULL)
		error("change_personality", "Unable to allocate directory");
	if((command==NULL)||((position+2)>=command->size)) {
		directory=(char *)nrealloc(directory, sizeof(char)*(strlen(DEFAULT)+1));
		if(directory==NULL)
			error("change_personality", "Unable to allocate directory");
		strcpy(directory, DEFAULT);
		if(last==NULL) last=mystrdup(directory);
	} else {
		directory=(char *)nrealloc(directory,
			sizeof(char)*(command->entry[position+2].length+1));
		if(directory==NULL)
			error("change_personality", "Unable to allocate directory");
		strncpy(directory, command->entry[position+2].word,
			command->entry[position+2].length);
		directory[command->entry[position+2].length]='\0';
	}
*/

	load_personality(model);

}

/*---------------------------------------------------------------------------*/

static void free_words(DICTIONARY *words)
{
	register int i;

	if(words==NULL) return;

	if(words->entry!=NULL) 
		for(i=0; i<words->size; ++i) free_word(&(words->entry[i]));

}

/*---------------------------------------------------------------------------*/

static void free_word(STRING *word)
{
	nfree(word->word);
}

/*===========================================================================*/
/* vd */
/*===========================================================================*/
static void save_msg(MODEL *model)
{
    FILE *file;
    static char *filename=NULL;
    BYTE4 savusage;
    BYTE2 savcount;
    BYTE2 savbranch;

    Context;

    filename = ".msg";
    file=openfile(filename, "w");
    if(file==NULL) {
	warn("save_msg", "Unable to open file `%s%s'", megfileprefix,filename);
	return;
    }
    savusage=model->forward->usage;
    savcount=model->forward->count;
    savbranch=model->forward->branch;

    model->forward->usage=savbranch;
    model->forward->count=savbranch;
    model->forward->branch=savbranch;


    model->backward->usage=savbranch;
    model->backward->count=savbranch;
    model->backward->branch=savbranch;


    msg_cleartreeusage(model->forward);
    msg_cleartreeusage(model->backward);

/* -------- */
    initialize_context(model); 
    model->halcontext[0]=model->backward; 

    msgsave_tree(file, model->backward);
    fclose(file);
/* -------- */

    model->forward->branch=savbranch;
    model->backward->branch=savbranch;

    msg_restoretreeusage(model->forward);
    msg_restoretreeusage(model->backward);

    model->forward->usage=savusage;
    model->forward->count=savcount;
    model->backward->usage=savusage;
    model->backward->count=savcount;

    
}
/*---------------------------------------------------------------------------*/
static void msgsave_tree(FILE *file, TREE *nodein)
{
    static BYTE2 *symbols_order=NULL;
    static BYTE2 *symbols_output=NULL;
    static unsigned char *output=NULL;
    static int length;
    static int level=0;
    register int i;
    register int j;
    register int k;
    int symbols_index=0;
    TREE *node=NULL;
    BYTE2 symbol;

    if(symbols_order==NULL) symbols_order=(BYTE2 *)nmalloc(sizeof(BYTE2)*(model->order+2)+1);
    if(symbols_output==NULL) symbols_output=(BYTE2 *)nmalloc(sizeof(BYTE2)*MAXOUTPUTSYMBOLS+1);
    if(output==NULL) output=(char *)nmalloc(sizeof(char)*MAXOUTPUT+1);

    symbol=nodein->symbol;
    symbols_order[(model->order+2-level)] = symbol;

    if((nodein->branch==0)&&(symbol==1)&&(level==(model->order+1))) {
      symbols_index=0;
      output[0]='\0';
      length=0;
      initialize_context(model); 
      model->halcontext[0]=model->backward; 
      for(j=level;j>=1;--j) {
        symbol=symbols_order[j];
        update_context(model, symbol);
        symbols_output[++symbols_index]=symbol;
	if(symbol==1) break;
      }
      while(1) {
        for(j=0; j<=model->order; ++j)
          if(model->halcontext[j]!=NULL) 
            node=model->halcontext[j];
        if(node->branch==0) break;
        symbol=node->tree[node->usage]->symbol;
        node->usage+=1;
        if(node->usage>=node->branch) node->usage=0;
        update_context(model, symbol);
        symbols_output[++symbols_index]=symbol;
	if(symbol==1) break;
      }	

      initialize_context(model); 
      model->halcontext[0]=model->forward; 

      for(k=symbols_index;k>0;--k) {
        symbol=symbols_output[k];
        update_context(model, symbol);
        if(symbol>1) msg_makeoutput(output, &length, symbol);
      }	
      while(1) {
        for(j=0; j<=model->order; ++j)
          if(model->halcontext[j]!=NULL) 
            node=model->halcontext[j];
        if(node->branch==0) break;
	if(symbol==1) break;
        symbol=node->tree[node->usage]->symbol;
        node->usage+=1;
        if(node->usage>=node->branch) node->usage=0;
        update_context(model, symbol);
        if(symbol>1) msg_makeoutput(output, &length, symbol);
      }	
      capitalize(output);
      fprintf(file, "%s\n",output); 
    }
    for(i=0; i<nodein->branch; ++i) {
	++level;
        msgsave_tree(file, nodein->tree[i]); 
	--level;
    }
    if(level==0){
      nfree(symbols_order);
      nfree(symbols_output);
      nfree(output);
      symbols_order=NULL;
      symbols_output=NULL;
      output=NULL;
    }
}
/*---------------------------------------------------------------------------*/
static void msg_makeoutput(char *output, int *length, BYTE2 symbol)
{
    register int j;

    if((*length>0)&&(strchr(charspaces, model->dictionary->entry[symbol].word[0])==NULL)&&(strchr(charspaces, output[(*length-1)])==NULL)) {
	    output[*length]='\040';
	    *length+=1;
    }
    for(j=0; j<model->dictionary->entry[symbol].length; ++j) {
	if(model->dictionary->entry[symbol].word[j] == '\t') {
	  output[*length]='\0';
	  *length+=1;
	  break;
	}
	else
	  output[*length]=model->dictionary->entry[symbol].word[j];
	*length+=1;
    }
    output[*length]='\0';
}

/*---------------------------------------------------------------------------*/
static void msg_cleartreeusage(TREE *node)
{
    register int i;

    node->usage=0;

    for(i=0; i<node->branch; ++i) {
        msg_cleartreeusage(node->tree[i]); 
    }
}
/*---------------------------------------------------------------------------*/
static void msg_restoretreeusage(TREE *node)
{
    register int i;

    if(node->branch==0)
      node->usage=0;
    else
      node->usage=node->count;

    for(i=0; i<node->branch; ++i) {
        msg_restoretreeusage(node->tree[i]); 
    }
}
/*---------------------------------------------------------------------------*/
static bool swap_badwords(DICTIONARY *words)
{
    register int i;
    int k=0;
    bool ret = FALSE;
    int position;

    for(i=0; i<words->size; ++i) {
      if( !((words->entry[i].length==1)&&(words->entry[i].word[0]=='\040'))) { 
        words->entry[k]=words->entry[i];
        position = find_word(mat->dictionary, words->entry[k]);
	if (position) {
	  if (!meg_noswapbadword)
	  words->entry[k] = mat->to[position];
	  ret = TRUE;
	}
	++k;
      } 
    } 
    words->size=k;
    if (!meg_badword) ret = FALSE;
    return ret;
}
/*---------------------------------------------------------------------------*/
static int expmem_model(void)
{
	int size=0;
        globsize = 0;
	if(model==NULL) return(0);
	if(model->forward!=NULL) {
		size+=expmem_tree(model->forward);
	}
        globsize = 0;
	if(model->backward!=NULL) {
		size+=expmem_tree(model->backward);
	}
	if(model->dictionary!=NULL) {
		size+=expmem_dictionary(model->dictionary);
	}
	return(size);
}
/*---------------------------------------------------------------------------*/
static int expmem_tree(TREE *tree)
{
	register int i;

	if(tree==NULL) return(globsize);
        globsize+= sizeof(TREE) + 4 + 10;
	if(tree->tree!=NULL) {
		for(i=0; i<tree->branch; ++i) {
			expmem_tree(tree->tree[i]);
		}
	}
	return(globsize);
}
/*---------------------------------------------------------------------------*/
static int expmem_dictionary(DICTIONARY *word)
{
	register int i;
	int size=0;

	if(word==NULL) return size;
	size = (word->size * (sizeof(STRING) +sizeof(BYTE2)) ) + sizeof(DICTIONARY);
	for(i=0;i<word->size;++i) 
          size+=word->entry[i].length +1;
	return size;
}
/*---------------------------------------------------------------------------*/
static int expmem_swap(SWAP *swap)
{
	register int i;
	int size=0;

	if(swap==NULL) return size;
	
	size = (swap->dictionary->size * ((sizeof(STRING)+sizeof(BYTE2)) * 2) + sizeof(SWAP) +sizeof(DICTIONARY));

	for(i=0;i<swap->dictionary->size;++i) {
          size+=swap->dictionary->entry[i].length +1;
          size+=swap->to[i].length +1;
        }
	return size;
}

static int expmem_users(USERS *users)
{
	register int i;
	int size=0;

	if(users==NULL) return size;
	
	size  = expmem_dictionary(users->dictionary);
	size += users->dictionary->size * sizeof(USERSTATUS);

	for(i=0;i<users->dictionary->size;++i) {
          size+=users->user[i].flood.size * sizeof(time_t);
        }
	return size;
}
/*---------------------------------------------------------------------------*/
static FILE *open_logfile(char *logprefix)
{
	register int i;
	FILE *file;
	static unsigned char *retnick;

	retnick = (unsigned char *)totranslit(logprefix);

	for(i=0;i< strlen(retnick);++i) {
	  if(strchr(badchar, retnick[i]) !=NULL) retnick[i] = '!';
	}
	
	sprintf(logfilename, "%s%s%s.%s", meglogpatch, SEP, megfileprefix, retnick);
	file=fopen(logfilename, "a");
	if(file==NULL) {
		warn("open_logfile", "Unable to open file `%s'", logfilename);
		return(NULL);
	}
	return(file);
}

static int findminlengch_dictionary(DICTIONARY *word)
{
	register int i;
	int size=255;

	if(word==NULL) return(0);
	for(i=0;i<word->size;++i) {
	  if(word->entry[i].length < size)
          size=word->entry[i].length;
        }
	return(size);
}

static void initialize_translit(void)
{
	register int i;
	FILE *file=NULL;
	unsigned char buffer[INBUFSIZE];
	unsigned char *from;
	unsigned char *to;
	char *filetranslit=".translit";

	for(i=0;i<128;i++) {
	  transtab[i] = nullchar;
	}

	file=openfile(filetranslit, "r");
	if(file==NULL) {
	  error("initialize_translit","Unable to open file %s%s", megfileprefix,filetranslit);
	  return;
	}
	while(!feof(file)) {
	  if(fgets(buffer, INBUFSIZE, file)==NULL) break;
	  if(buffer[0] < 128) continue;
	  from=strtok(buffer, "\t ");
	  to=strtok(NULL, "\t \r\n#");
	  transtab[(from[0]-128)] = mystrdup(to);
	}

	fclose(file);
}

static unsigned char *totranslit(unsigned char *source)
{
	static unsigned char buf[2048];
        unsigned char *retval=buf, *in=source, *tmp;
	unsigned char  *max = &buf[sizeof(buf)-2];

	while(*in && (retval < max)) {
          if(*in > 127) {
            tmp = transtab[(*in-128)];
	    while(*tmp) 
	      *retval++ = *tmp++;
	  } else *retval++ = *in;
	  in++;
	}
	*retval = 0;
	return buf;
}

static FILE *openfile(char *name, char *mode)
{
  FILE *file=NULL;
  static char *filename=NULL;

  if(filename==NULL) filename=(char *)nmalloc(sizeof(char)*1);
  filename=(char *)nrealloc(filename, sizeof(char)*(strlen(directory)+strlen(SEP)+strlen(megfileprefix)+strlen(name)+1));
  if(filename==NULL) {
    error("openfile","Unable to allocate filename %s", name);
  } else {
    sprintf(filename, "%s%s%s%s", directory, SEP, megfileprefix, name);
    if(filename==NULL) {
      error("openfile","no open file, filename is NULL");
    } else {
      file=fopen(filename, mode);
      nfree(filename);
      filename=NULL;
    }
  }
  return file;
}

static void initialize_codepage(void)
{

  int i, length;
  unsigned char touppertab[193];
  CONST char *uppertab;
  unsigned char mychar[] = "1";

  for(i=0;i<64;i++) {
    meg_tolowertab[i] = i;
    meg_touppertab[i] = i;
  }

  for(i=0;i<192;i++) touppertab[i] = i+64;
  touppertab[192] = 0;

  if (Tcl_MegConvertToUpLo(interp, meg_codepage, touppertab, TRUE) != TCL_OK) return;
  uppertab = Tcl_GetStringFromObj(Tcl_GetObjResult(interp), &length); 
  for(i=0;i<192;i++) meg_touppertab[(i+64)] = uppertab[i];

  if (Tcl_MegConvertToUpLo(interp, meg_codepage, touppertab, FALSE) != TCL_OK) return;
  uppertab = Tcl_GetStringFromObj(Tcl_GetObjResult(interp), &length); 
  for(i=0;i<192;i++) meg_tolowertab[(i+64)] = uppertab[i];

  mychar[1] = 0;
  for(i=0;i<256;i++) meg_is[i] = 0;
                                       
  for(i=1;i<256;i++) {
    mychar[0] = i;
    (void)Tcl_MegEncodingConvertFrom(interp, meg_codepage, mychar);

    Tcl_SetVar(interp, "_megcpstringutf", Tcl_GetString(Tcl_GetObjResult(interp)), 0);

    Tcl_Eval(interp,"set _megcpbool \377");
    Tcl_Eval(interp,"if {[string is alpha $_megcpstringutf]} then {set _megcpbool \001}");
    uppertab = Tcl_GetVar(interp, "_megcpbool", TCL_GLOBAL_ONLY);
    if(*uppertab == 1) meg_is[i] |= MEG_ISALPHA;

    Tcl_Eval(interp,"set _megcpbool \377");
    Tcl_Eval(interp,"if {[string is alnum $_megcpstringutf]} then {set _megcpbool \001}");

    uppertab = Tcl_GetVar(interp, "_megcpbool", TCL_GLOBAL_ONLY);
    if(*uppertab == 1) meg_is[i] |= MEG_ISALNUM;
  }
}
/*
 *----------------------------------------------------------------------
 *
 * See Tcl 8.4... Tcl_EncodingObjCmd
 *
 *----------------------------------------------------------------------
 */

static int Tcl_MegEncodingConvertFrom(Tcl_Interp *myinterp, char *codepage, char *src)
{
    int length;
    Tcl_Encoding encoding;
    char *string;
    Tcl_DString ds;

    encoding = Tcl_GetEncoding(myinterp, codepage);
    if (!encoding) {
	return TCL_ERROR;
    }
    length = strlen(src);
    string = src;

    Tcl_ExternalToUtfDString(encoding, string, length, &ds);

    Tcl_SetStringObj(Tcl_GetObjResult(myinterp),Tcl_DStringValue(&ds), Tcl_DStringLength(&ds));
    Tcl_DStringFree(&ds);
    
    Tcl_FreeEncoding(encoding);
    return TCL_OK;
}

/*
 *----------------------------------------------------------------------
 *
 * See Tcl 8.4... Tcl_EncodingObjCmd
 *
 *----------------------------------------------------------------------
 */
static int Tcl_MegEncodingConvertTo(Tcl_Interp *myinterp, char *codepage, char *data, int length)
{
    Tcl_Encoding encoding;
    Tcl_DString ds;
	    
    encoding = Tcl_GetEncoding(myinterp, codepage);
    if (!encoding) {
	return TCL_ERROR;
    }

    Tcl_UtfToExternalDString(encoding, data, length, &ds);

    Tcl_SetStringObj(Tcl_GetObjResult(myinterp),
	Tcl_DStringValue(&ds), Tcl_DStringLength(&ds));
    Tcl_DStringFree(&ds);

    Tcl_FreeEncoding(encoding);
    return TCL_OK;
}

static int Tcl_MegConvertToUpLo(Tcl_Interp *myinterp, char *codepage, char *data, bool isu)
{
  int length;
  char *string, *byteptr;
  Tcl_Obj *resultPtr;

  if (Tcl_MegEncodingConvertFrom(interp, codepage, data) != TCL_OK) {
     error("initialize_codepage", "Unable to encoding codepage %s.", codepage);
     return TCL_ERROR;
  }
  resultPtr = Tcl_GetObjResult(myinterp);

  if (isu)
    length = Tcl_UtfToUpper(Tcl_GetString(resultPtr));
  else
    length = Tcl_UtfToLower(Tcl_GetString(resultPtr));

  Tcl_SetObjLength(resultPtr, length);

  byteptr = (char *) Tcl_GetStringFromObj(resultPtr, &length);
  string  = (char *) nmalloc(length + 1);
  strncpy(string, byteptr, length);
  string[length] = 0;

  if (Tcl_MegEncodingConvertTo(myinterp, codepage, string, length)) {
     error("initialize_codepage", "Unable to encoding codepage %s.", codepage);
     nfree(string);
     return TCL_ERROR;
  }
  nfree(string);

  return TCL_OK;
}



/* lib for USERS */

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Add_User
 *
 *		Purpose:		Add a user to a users, and return the identifier
 *						assigned to the word.  If the word already exists in
 *						the users, then return its current identifier
 *						without adding it again.
 */
static BYTE2 add_user(USERS *users, STRING word)
{
	int position;
	BYTE4 size;
	bool found;
	BYTE2 index;

	/*
	 *		If the word's already in the users, there is no need to add it
	 */
	position=search_dictionary(users->dictionary, word, &found);
	if(found==TRUE) goto succeed;

	index = add_wordnew(users->dictionary, word, position);

	/*
	 *		Allocate one more entry for the user array
	 */
	if(users->user==NULL) {
		users->user=(USERSTATUS *)nmalloc(sizeof(USERSTATUS)*(users->dictionary->size));
	} else {
		users->user=(USERSTATUS *)nrealloc((USERSTATUS *)(users->user),
		sizeof(USERSTATUS)*(users->dictionary->size));
	}
	if(users->user==NULL) {
		error("add_users", "Unable to nreallocate the users to %d elements.", users->dictionary->size);
		goto fail;
	}

	/*
	 *		Copy the new word into the word array
	 */
	size = users->dictionary->size - 1;

	users->user[size].status=0;
	users->user[size].lastused=0;
	users->user[size].ignore=0;
	users->user[size].flood.size=0;
	users->user[size].flood.time=(time_t *)nmalloc(sizeof(time_t)*1);
	users->user[size].flood.time[0]=0;

succeed:
	return(users->dictionary->index[position]);

fail:
	return (-1);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	New_User
 *
 *		Purpose:		Allocate a new user for the users, and initialise
 *						its contents to sensible values.
 */
static USERSTATUS *new_user(void)
{
	USERSTATUS *user=NULL;

	/*
	 *		Allocate memory for the new user
	 */
	user=(USERSTATUS *)nmalloc(sizeof(USERSTATUS));
	if(user==NULL) {
		error("new_user", "Unable to allocate the user.");
		goto fail;
	}

	/*
	 *		Initialise the contents of the user
	 */
	user->status=0;
	user->lastused=0;
	user->ignore=0;
	user->flood.size=0;
	user->flood.time=NULL;

	return(user);

fail:
	if(user!=NULL) nfree(user);
	return(NULL);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	New_USERS
 *
 *		Purpose:		Allocate room for a new USERS.
 */
static USERS *new_users(void)
{
	USERS *users=NULL;

	users=(USERS *)nmalloc(sizeof(USERS));
	if(users==NULL) {
		error("new_users", "Unable to allocate users.");
		return(NULL);
	}
	users->dictionary=new_dictionary();
	users->user=new_user();

	return(users);
}

static USERS *initialize_users(char *filename)
{
        USERS *users;
	FILE *file=NULL;
	STRING word;
	BYTE2 status;
	time_t lastused;
	time_t ignore;
	int position;
	unsigned char *string;
	unsigned char buffer[INBUFSIZE];

	Context;

	users=new_users();

	if(filename==NULL) return(users);

	file=openfile(filename, "r");
	if(file==NULL) return(users);

	while(!feof(file)) {
	  if(fgets(buffer, INBUFSIZE, file)==NULL) break;
	  if(buffer[0]=='#') continue;
	  upper(buffer);

	  string=strtok(buffer, "\t ");
	  if((string==NULL) || (strlen(string)==0)) continue;

          status= (BYTE2) atoi(strtok(NULL, "\t "));
          lastused=(time_t) atoi(strtok(NULL, "\t "));
          ignore=(time_t) atoi(strtok(NULL, "\t \r\n#"));

	  if ((ignore >= systime) || status) {
	    word.length=strlen(string);
	    word.word=mystrdup(buffer);
	    position = add_user(users, word);
	    if(position != (-1)) {
	      users->user[position].status=status;
	      users->user[position].lastused=lastused;
	      users->user[position].ignore=ignore;
	    }
	    if (word.word != NULL) nfree(word.word);
	  }
	}

	fclose(file);
	return(users);
}

static void free_flood(MSGFLOOD *flood)
{
	nfree(flood->time);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Free_Users
 *
 *		Purpose:		Release the memory consumed by the dictionary.
 */
static void free_users(USERS *users)
{
	register int i;
	if(users==NULL) return;

	if(users->user!=NULL) {
	  for(i=0; i<users->dictionary->size; ++i) free_flood(&(users->user[i].flood));
	  nfree(users->user);
	  users->user=NULL;
	}

	if(users->dictionary!=NULL) {
		free_words(users->dictionary);
		free_dictionary(users->dictionary);
		nfree(users->dictionary);
                users->dictionary=NULL;
	}
}

static void megahal_writeuserfile(void)
{
	save_users(usr,".usr");
	save_logbuffer();
}

static void megahal_clearhello(void)
{
    register int i;

    systime = time(NULL);
    for(i=0; i<usr->dictionary->size; ++i) 
      usr->user[i].status &= ~MEG_ISHELLO;
    megahal_writeuserfile();
    free_users(usr);
    if(usr!=NULL) {
      nfree(usr);
      usr=NULL; 
    }
    usr=initialize_users(".usr");

}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Save_Users
 *
 *		Purpose:		Save the current state to a MegaHAL users file.
 */
static void save_users(USERS *users, char *usrfile)
{
	register int i;
	FILE *file=NULL;
	static char srcfilename[255];
//	static char dstfilename[255];
	Context;
	save_eggdroplog();
	
	sprintf(srcfilename, "%s%s%s%s", directory, SEP, megfileprefix, usrfile);
//	sprintf(dstfilename, "%s~bak", srcfilename);

//	copyfile(srcfilename, dstfilename);

	file=openfile(usrfile, "w");
	if(file==NULL) {
		warn("save_users", "Unable to open file `%s%s'",megfileprefix , usrfile);
		return;
	}

	for(i=0; i<users->dictionary->size; ++i) {
	  if ((users->user[i].ignore >= systime) || users->user[i].status) {
	    fwrite(users->dictionary->entry[i].word, sizeof(char), users->dictionary->entry[i].length, file);
	    fprintf(file, " %d %lu %lu\n", users->user[i].status, users->user[i].lastused,users->user[i].ignore);
	  }
	}

	fclose(file);
}

/*---------------------------------------------------------------------------*/

/*
 *		Function:	Save_Swap
 *
 *		Purpose:		Save the current state to a MegaHAL swap file.
 */
/*
static void save_swap(SWAP *swap, char *usrfile)
{
	register int i;
	FILE *file=NULL;
	static char srcfilename[255];
	static char dstfilename[255];
	int position;
	Context;
	
	sprintf(srcfilename, "%s%s%s%s", directory, SEP, megfileprefix, usrfile);
	sprintf(dstfilename, "%s~bak", srcfilename);

	copyfile(srcfilename, dstfilename);

	file=openfile(usrfile, "w");
	if(file==NULL) {
		warn("save_swap", "Unable to open file `%s%s'",megfileprefix , usrfile);
		return;
	}
	putlog(LOG_MISC, "*", "Writing megahal users file...");

	for(i=0; i<swap->dictionary->size; ++i) {
	    position = swap->dictionary->index[i];
	    fwrite(swap->dictionary->entry[position].word, sizeof(char), swap->dictionary->entry[position].length, file);
	    fprintf(file, "\t");
	    fwrite(swap->to[position].word, sizeof(char), swap->to[position].length, file);
	    fprintf(file, "\n");
	}

	fclose(file);
}
*/

static bool getbaduser(USERS *users, char *host, struct userrec *u)
{
	STRING word;
	char userhost[255];

	if (u) {
	  if (meg_noignoreflag[0])
	    if (matchattr(u, meg_noignoreflag, NULL)) return FALSE;
	  if (meg_ignoreflag[0])
	    if (matchattr(u, meg_ignoreflag, NULL)) return TRUE;
	}

	word.length=mystrncpy(userhost,host,254);
	word.word=userhost;
	upper(word.word);

	usersposition = add_user(users, word);
	if(usersposition != (-1)) {
	  users->user[usersposition].lastused = systime;
	  if (isignorebyflood(users, usersposition)) return TRUE;
	  if (isignorebybadword(users, usersposition)) return TRUE;
	}

	return FALSE;
}

/*
#define MEG_ISHELLO         0x00004
*/

static bool detectflood(MSGFLOOD *flood)
{
    register int i=0,j=0;
    time_t starttime = systime - meg_flood_time;

    for(;((i<flood->size) && (flood->time[i] < starttime)); ++i);

    for(;i<flood->size; ++i) {
      flood->time[j] = flood->time[i];
      ++j;
    }
    flood->size = ++j;

    if(flood->time==NULL) {
	flood->time=(time_t *)nmalloc(sizeof(time_t)*(flood->size));
    } else {
	flood->time=(time_t *)nrealloc((time_t *)(flood->time),sizeof(time_t)*(flood->size));
    }
    if(flood->time==NULL) {
	error("detectflood", "Unable to nreallocate the users-flood to %d elements.", flood->size);
        return FALSE;
    }

    flood->time[flood->size-1]=systime;
    if (flood->size >= meg_flood_count) return TRUE;

    return FALSE;
}

static bool isignorebyflood(USERS *users, int position)
{
    if ((!meg_flood_count) || (!meg_flood_time) || (!meg_ignore_isflood)) return FALSE;
    if (detectflood(&(users->user[position].flood))) {
      if (users->user[position].ignore < meg_ignore_isflood * 60 + systime)
        users->user[position].ignore = meg_ignore_isflood * 60 + systime;
      return TRUE;
    }
    if (users->user[position].ignore == 0) return FALSE;
    if (users->user[position].ignore >= systime) return TRUE;
    users->user[position].ignore = 0;
    return FALSE;
}

static bool isignorebybadword(USERS *users, int position)
{
    if ((!meg_badword) || (!users->user[position].ignore)) return FALSE;
    if (users->user[position].ignore >= systime) return TRUE;
    users->user[position].ignore = 0;
    return FALSE;
}

static void ignoreuserbadwords(USERS *users, char *host)
{
    if (usersposition != (-1))
    if (users->user[usersposition].ignore < meg_badword * 60 + systime)
      users->user[usersposition].ignore = meg_badword * 60 + systime;
}

static bool isfreereplay(char *channel, DICTIONARY *message)
{
   register int i;
   int megfreemode = ngetudef("megfreemode", channel);

   if (ngetudef("nomegfreehello", channel) ==0) {
     if ((message->size) && (find_word(hello, message->entry[0]))) {
       if ((usr->user[usersposition].status & MEG_ISHELLO) == 0) {
	 usr->user[usersposition].status |= MEG_ISHELLO;
         return HELLO;
       } 
       return FALSE;
     }
   }

   if (megfreemode == 1) return TRUE;
   if (megfreemode > 1) {
     if (megfreemodecount) megfreemodecount -= 1;
     if (!megfreemodecount) {
       megfreemodecount = randint(megfreemode);
       return TRUE;
     }
   }
   if (ngetudef("megfreekey", channel) !=0) {
     for(i=0; i<message->size; ++i) {
       if (find_word(key, message->entry[i])) return TRUE;
     }
   }
   return FALSE;
}

static LOGPOOL *new_logpool(void)
{
	LOGPOOL *pool=NULL;

	pool=(LOGPOOL *)nmalloc(sizeof(LOGPOOL));
	if(pool==NULL) {
		error("new_user", "Unable to allocate the user.");
		goto fail;
	}

	pool->size=0;
	pool->line=NULL;

	return(pool);

fail:
	if(pool!=NULL) nfree(pool);
	return(NULL);
}

static LOGS *new_logbuffer(void)
{
	LOGS *buf=NULL;

	Context;
	buf=(LOGS *)nmalloc(sizeof(LOGS));
	if(buf==NULL) {
		error("new_users", "Unable to allocate logbuffer.");
		return(NULL);
	}

	buf->dictionary=new_dictionary();
	buf->pool=new_logpool();

	return(buf);
}

static void add_logbuffer(char *name, char *fmt, ...)
{
	int position;
	BYTE4 size;
	bool found;
	BYTE2 index;
	STRING word;
	va_list argp;
	char message[INBUFSIZE];
	
	if (logbuf==NULL) logbuf=new_logbuffer();
	word.word=name;
	word.length=strlen(name);

	va_start(argp, fmt);
	vsprintf(message, fmt, argp);
	va_end(argp);

	/*
	 *		If the word's already in the logbuf, there is no need to add it
	 */
	position=search_dictionary(logbuf->dictionary, word, &found);
	if(found==TRUE) goto succeed;

	index = add_wordnew(logbuf->dictionary, word, position);

	/*
	 *		Allocate one more entry for the user array
	 */

	if(logbuf->pool==NULL) {
		logbuf->pool=(LOGPOOL *)nmalloc(sizeof(LOGPOOL)*(logbuf->dictionary->size));
	} else {
		logbuf->pool=(LOGPOOL *)nrealloc((LOGPOOL *)(logbuf->pool),
		sizeof(LOGPOOL)*(logbuf->dictionary->size));
	}
	if(logbuf->pool==NULL) {
		error("add_logbuf", "Unable to nreallocate the logbuf to %d elements.", logbuf->dictionary->size);
		return;
	}

	/*
	 *		Copy the new word into the word array
	 */

	logbuf->pool[logbuf->dictionary->size-1].size=0;
	logbuf->pool[logbuf->dictionary->size-1].line=(unsigned char **)nmalloc(sizeof(unsigned char *));
	logbuf->pool[logbuf->dictionary->size-1].line[0]=NULL;

succeed:

	size = logbuf->dictionary->index[position];

	logbuf->pool[size].size += 1;

	if(logbuf->pool[size].line==NULL) {
		logbuf->pool[size].line=(unsigned char **)nmalloc(sizeof(unsigned char *)*(logbuf->pool[size].size));
	} else {
		logbuf->pool[size].line=(unsigned char **)nrealloc((unsigned char **)(logbuf->pool[size].line),
		sizeof(unsigned char *)*(logbuf->pool[size].size));
	}
	if(logbuf->pool[size].line==NULL) {
		error("add_logbuf", "Unable to nreallocate the logbuf to %d elements.", logbuf->dictionary->size);
		return;
	}
	logbuf->pool[size].line[logbuf->pool[size].size-1]=mystrdup(message);

	return;
}

static void save_logbuffer(void)
{
	register int i;

	Context;
	save_eggdroplog();
	if (logbuf==NULL) return;
	if (logbuf->dictionary==NULL) return;

	for(i=0; i<logbuf->dictionary->size; ++i) {
	  save_pool(&(logbuf->pool[i]), &(logbuf->dictionary->entry[i]));
	  if (logbuf->pool[i].line!=NULL) {
	    nfree(logbuf->pool[i].line);
	    logbuf->pool[i].line=NULL;
	  }
	}

	if (logbuf->pool!=NULL) {
	  if (logbuf->pool->line!=NULL){
	    nfree(logbuf->pool->line);
	    logbuf->pool->line=NULL;
	  }
	  nfree(logbuf->pool);
	  logbuf->pool=NULL;
	}
	if(logbuf->dictionary!=NULL) {
		free_words(logbuf->dictionary);
		free_dictionary(logbuf->dictionary);
		nfree(logbuf->dictionary);
                logbuf->dictionary=NULL;
	}
	nfree(logbuf);
	logbuf=NULL;
	return;
}

static void save_pool(LOGPOOL *pool, STRING *word)
{
	register int i;
	FILE *file=NULL;
	char filename[128];
	Context;

	if (pool==NULL)	return;
	if (pool->size==0) return;

	strncpy(filename, word->word, word->length);
	filename[word->length]=0;

	file = open_logfile(filename);

	if(file==NULL) return;

	for(i=0; i<pool->size; ++i) {
          fprintf(file, "%s",pool->line[i]);
	  nfree(pool->line[i]);
	  pool->line[i]=NULL;
	}

	fclose(file);
}

/* stolen from tcl_matchattr */
static int matchattr (struct userrec *u, char *flags, char *chan) 
{
  struct flag_record plus, minus, user;
  int ok = 0, f;

  if (u && (!chan || findchan_by_dname(chan))) {
    user.match = FR_GLOBAL | (chan ? FR_CHAN : 0) | FR_BOT;
    get_user_flagrec(u, &user, chan);
    plus.match = user.match;
    break_down_flags(flags, &plus, &minus);
    f = (minus.global || minus.udef_global || minus.chan || minus.udef_chan || minus.bot);
    if (flagrec_eq(&plus, &user)) {
      if (!f)
        ok = 1;
      else {
        minus.match = plus.match ^ (FR_AND | FR_OR);
        if (!flagrec_eq(&minus, &user))
        ok = 1;
      }
    }
  }
  return ok;
}


/*===========================================================================*/
/*
 *		$Log: megahal.c,v $
 *		Revision 1.25  1999/10/21 03:42:48  hutch
 *		Fixed problem on some operating systems caused by stderr and stdout not
 *		being of type FILE *.
 *
 * Revision 1.24  1998/09/03  03:07:09  hutch
 * Don't know.
 *
 *		Revision 1.23  1998/05/19 03:02:02  hutch
 *		Removed a small nmalloc() bug, and added a progress display for
 *		generate_reply().
 *
 *		Revision 1.22  1998/04/24 03:47:03  hutch
 *		Quick bug fix to get sunos version to work.
 *
 *		Revision 1.21  1998/04/24 03:39:51  hutch
 *		Added the BRAIN command, to allow user to change MegaHAL personalities
 *		on the fly.
 *
 *		Revision 1.20  1998/04/22 07:12:37  hutch
 *		A few small changes to get the DOS version to compile.
 *
 *		Revision 1.19  1998/04/21 10:10:56  hutch
 *		Fixed a few little errors.
 *
 *		Revision 1.18  1998/04/06 08:02:01  hutch
 *		Added debugging stuff, courtesy of Paul Baxter.
 *
 *		Revision 1.17  1998/04/02 01:34:20  hutch
 *		Added the help function and fixed a few errors.
 *
 *		Revision 1.16  1998/04/01 05:42:57  hutch
 *		Incorporated Mac code, including speech synthesis, and attempted
 *		to tidy up the code for multi-platform support.
 *
 *		Revision 1.15  1998/03/27 03:43:15  hutch
 *		Added AMIGA specific changes, thanks to Dag Agren.
 *
 *		Revision 1.14  1998/02/20 06:40:13  hutch
 *		Tidied up transcript file format.
 *
 *		Revision 1.13  1998/02/20 06:26:19  hutch
 *		Fixed random number generator and Seed() function (thanks to Mark
 *		Tarrabain), removed redundant code left over from the Loebner entry,
 *		prettied things up a little and destroyed several causes of memory
 *		leakage (although probably not all).
 *
 *		Revision 1.12  1998/02/04 02:55:11  hutch
 *		Fixed up memory allocation error which caused SunOS versions to crash.
 *
 *		Revision 1.11  1998/01/22 03:16:30  hutch
 *		Fixed several memory leaks, and the frustrating bug in the
 *		Write_Input routine.
 *
 *		Revision 1.10  1998/01/19 06:44:36  hutch
 *		Fixed MegaHAL to compile under Linux with a small patch credited
 *		to Joey Hess (joey@kitenet.net).  MegaHAL may now be included as
 *		part of the Debian Linux distribution.
 *
 *		Revision 1.9  1998/01/19 06:37:32  hutch
 *		Fixed a minor bug with end-of-sentence punctuation.
 *
 *		Revision 1.8  1997/12/24 03:17:01  hutch
 *		More bug fixes, and hopefully the final contest version!
 *
 *		Revision 1.7  1997/12/22  13:18:09  hutch
 *		A few more bug fixes, and non-repeating implemented.
 *
 *		Revision 1.6  1997/12/22 04:27:04  hutch
 *		A few minor bug fixes.
 *
 *		Revision 1.5  1997/12/15 04:35:59  hutch
 *		Final Loebner version!
 *
 *		Revision 1.4  1997/12/11 05:45:29  hutch
 *		The almost finished version.
 *
 *		Revision 1.3  1997/12/10 09:08:09  hutch
 *		Now Loebner complient (tm).
 *
 *		Revision 1.2  1997/12/08 06:22:32  hutch
 *		Tidied up.
 *
 *		Revision 1.1  1997/12/05  07:11:44  hutch
 *		Initial revision (lots of files were merged into one, RCS re-started)
 *
 *		Revision 1.7  1997/12/04 07:07:13  hutch
 *		Added load and save functions, and tidied up some code.
 *
 *		Revision 1.6  1997/12/02 08:34:47  hutch
 *		Added the ban, aux and swp functions.
 *
 *		Revision 1.5  1997/12/02 06:03:04  hutch
 *		Updated to use a special terminating symbol, and to store only
 *		branches of maximum depth, as they are the only ones used in
 *		the reply.
 *
 *		Revision 1.4  1997/10/28 09:23:12  hutch
 *		MegaHAL is babbling nicely, but without keywords.
 *
 *		Revision 1.3  1997/10/15  09:04:03  hutch
 *		MegaHAL can parrot back whatever the user says.
 *
 *		Revision 1.2  1997/07/21 04:03:28  hutch
 *		Fully working.
 *
 *		Revision 1.1  1997/07/15 01:55:25  hutch
 *		Initial revision.
 */
/*===========================================================================*/
